﻿using Bios.Communication.Packets.Outgoing.Moderation;
using Bios.Communication.Packets.Outgoing.Rooms.Notifications;
using Bios.HabboHotel.Rooms;


namespace Bios.Communication.Packets.Incoming.Rooms.Action
{
    class AmbassadorWarningMessageEvent : IPacketEvent
    {
        public void Parse(HabboHotel.GameClients.GameClient Session, ClientPacket Packet)
        {

            int UserId = Packet.PopInt();
            int RoomId = Packet.PopInt();
            int Time = Packet.PopInt();
            string HotelName = BiosEmuThiago.HotelName;

            Room Room = Session.GetHabbo().CurrentRoom;
            RoomUser Target = Room.GetRoomUserManager().GetRoomUserByHabbo(BiosEmuThiago.GetUsernameById(UserId));
            if (Target == null)
                return;

            long nowTime = BiosEmuThiago.CurrentTimeMillis();
            long timeBetween = nowTime - Session.GetHabbo()._lastTimeUsedHelpCommand;
            if (timeBetween < 60000)
            {
                Session.SendMessage(RoomNotificationComposer.SendBubble("ambassador", "Warte 1 Minute... bis du einen nächsten Habbo verwarnen kannst.", ""));
                return;
            }

            else
                BiosEmuThiago.GetGame().GetClientManager().StaffAlert(RoomNotificationComposer.SendBubble("advice", "" + Session.GetHabbo().Username + " hat " + Target.GetClient().GetHabbo().Username + " verwarnt, klick hier um in den Raum zu gelangen.", "event:navigator/goto/" + Session.GetHabbo().CurrentRoomId));
            Target.GetClient().SendMessage(new BroadcastMessageAlertComposer("<b><font size='15px' color='#c40101'>Du wurdest verwant!<br></font></b>Ein Botschafter findet dein Verhalten nicht angemessen. Dies ist eine Verwarnung. Solltest du dein Verhalten nicht ändern, so müssen wir dir leider deine 'Redefreiheit' für eine bestimmte Zeit entziehen. Sollte dies eine Fehlentscheidung sein, so melde dich gerne unter 'Hilfe'.<br>- AC Botschafter"));

            Session.GetHabbo()._lastTimeUsedHelpCommand = nowTime;
        }
    }
}
