﻿using System.Linq;
using System.Text;
using System.Collections.Generic;
using Bios.HabboHotel.GameClients;
using Bios.Communication.Packets.Outgoing.Rooms.Notifications;
using Bios.HabboHotel.Rooms.Chat.Commands.User;
using Bios.HabboHotel.Rooms.Chat.Commands.User.Fun;
using Bios.HabboHotel.Rooms.Chat.Commands.Moderator;
using Bios.HabboHotel.Rooms.Chat.Commands.Moderator.Fun;
using Bios.HabboHotel.Rooms.Chat.Commands.Administrator;
using Bios.Communication.Packets.Outgoing.Notifications;
using Bios.Database.Interfaces;
using Bios.HabboHotel.Rooms.Chat.Commands.Events;
using Bios.HabboHotel.Items.Wired;
using System;
using System.Diagnostics;
using System.Globalization;
using System.IO;
using System.Windows.Forms;
using System.Reflection;
using MySql.Data.MySqlClient;
using Bios.Core;
using Bios.HabboHotel;
using Bios.HabboHotel.Users;
using Bios.HabboHotel.Users.UserData;
using Bios.Communication.RCON;
using Bios.Communication.ConnectionManager;
using Bios.Utilities;
using log4net;
using System.Collections.Concurrent;
using Bios.Communication.Packets.Outgoing.Moderation;
using Bios.Communication.Encryption.Keys;
using Bios.Communication.Encryption;
using Bios.HabboHotel.Cache.Type;
using Bios.Database;




namespace Bios.HabboHotel.Rooms.Chat.Commands
{
    public class CommandManager
    {
        private string _prefix = ":";
        private readonly Dictionary<string, IChatCommand> _commands;
        public CommandManager(string Prefix)
        {
            this._prefix = Prefix;
            this._commands = new Dictionary<string, IChatCommand>();
            this.RegisterVIP();
            this.RegisterUser();
            this.RegisterEvents();
            this.RegisterModerator();
            this.RegisterAdministrator();
        }



        public bool Parse(GameClient Session, string Message)
        {
            if (Session == null || Session.GetHabbo() == null || Session.GetHabbo().CurrentRoom == null)
                return false;

            if (!Message.StartsWith(_prefix))
                return false;




            if (Message == _prefix + "dddbefehle")
            {
                StringBuilder List = new StringBuilder();
                List.Append("----------------Standard Befehle----------------\n\n" + // Standard Befehle
                    ":floor - Öffnet den RaumEditor.\n" +
                    ":pickall - Alle Möbel aus dem Raum werden aufgehoben.\n" +
                    ":ejectall - Alle Möbel von dir werden aus dem Raum aufgehoben.\n" +
                    ":emoji liste - Emojis im Chat abschicken.\n" +
                    ":empty - Dein Inventar wird geleert.\n" +
                    ":teleport - In deinem Raum deinen Teleportmodus aktivieren.\n" +
                    ":unload - Der Raum wird neugeladen.\n" +
                    ":fixroom - Raum wird neu regeniert.\n" +
                    ":flagme - Seinen Namen ändern.\n" +
                    ":gruppenchat - Den Gruppenchat aktivieren oder deaktivieren.\n" + // edit by HelpTool
                    ":setmax - Die Raumbesucheranzahl bestimmen.\n" +
                    ":setspeed - Die Rollergeschwindigkeit im Raum bestimmen.\n" +
                    ":mutepets - Alle Tiere im Raum werden stummgeschaltet.\n" +
                    ":kickpets - Alle Tiere im Raum werden aus dem Raum gekickt.\n" +
                    ":mutebots - Alle Bots im Raum werden stummgeschaltet.\n" +
                    ":kickbots - Alle Bots im Raum werden aus dem Raum gekickt.\n" +
                    ":convertcredits - Alle Taler-Möbel im Inventar zu Talern umwandeln.\n" +
                    ":wm <Habbo> - Einen Habbo melden.\n" +
                    ":convertduckets - Alle Ducket-Möbel im Inventar zu Duckets umwandeln.\n\n" +
                    "----------------Interaktions Befehle----------------\n\n" + // Interaktions Befehle
                    ":wil <Habbo> - Einen Habbo im Hotel begrüßen." +
                    ":enable <EffektID> - Verschiedene Effekte anwenden.\n" +
                    ":push <Habbo> - Einen Habbo schubsen.\n" +
                    ":pull <Habbo> - Einen Habbo zu sich ziehen.\n" +
                    ":umarmen <Habbo> - Einen Habbo umarmen.\n" +
                    ":kill <Habbo> - Einen Habbo töten.\n" +
                    ":schlagen <Habbo> - Einen Habbo schlagen.\n" +
                    ":kuss <Habbo> - Einen Habbo küssen.\n" +
                    ":heilen - Sich selber heilen.\n" +
                    ":lay - Sich auf den Boden legen.\n" +
                    ":s - Sich auf den Boden setzen.\n" +
                    ":stand - Wieder aufstehen.\n" +
                    ":dance <1-4> - Einfach lostanzen.\n" +
                    ":moonwalk - Rückwärts laufen.\n" +
                    ":follow <Habbo> - Einem Habbo in den Raum folgen.\n" +
                    ":pet - Sich in ein Tier transformieren.\n\n" +
                    "----------------Raum Befehle----------------\n\n" +// Raum Befehle
                    ":room - Berechtigungen im Raum aktivieren/deaktivieren.\n" +
                    ":raumverkaufen <1c-900c> - Seinen eigenen Raum verkaufen.\n" +
                    ":raumkaufen - Einen Raum kaufen.\n\n" +
                    "----------------Premium Befehle----------------\n\n" + // Premium Befehle
                    ":spull <Habbo> - Einen Habbo aus einer sehr weiten Distanz zu sich ziehen.\n" +
                    ":spush <Habbo> - Einen Habbo sehr weit weg schubsen.\n" +
                    ":weed - Weed kiffen.\n" +
                    ":vipalert - Eine Alert an alle VIP-Mitglieder verschicken.\n\n" +
                    "----------------Befehle mit Kosten----------------\n\n" + // Befehle mit Kosten
                    ":werbung <Naricht> - Eine Alert im gesamten Hotel abschicken (10 Dias.).\n" +
                    ":eventbox - Was sich wohl dahinter verbirgt?\n\n" +
                    "----------------Konto Befehle----------------\n\n" + // Konto Befehle
                    ":stats - Zeigt deine Kontoinformationen an.\n" +
                    ":friends - Freundschaftsanfragen aktivieren/deaktivieren.\n" +
                    ":disablewhisper - Von anderen Habbos angeflüstert werden, aktivieren/deaktivieren.\n" +
                    ":disablegifts - Von anderen Habbos Geschenke erhalten, aktivieren/deaktivieren.\n" +
                    ":disablemimic - Andere Habbos können dein Outfit kopieren, aktivieren/deaktivieren.\n" +
                    "disabeleevents - Event-Benarichtigungen aktivieren/deaktivieren.\n\n" +
                    "----------------Hilfe----------------\n\n" + // Hilfe
                    ":hilfe <Naricht> - Eine kurze Frage stellen.\n" +
                    "----------------Neue Befehle----------------\n\n" +
                    ":wm <Habbo> - Einen Werber im Hotel melden.\n" +
                    ":idee <Habbo> - Deine Ideen einrreichen.\n" +
                    ":werbung <Naricht> - Eine Naricht im gesamten Hotel abschicken. (10 Dias)\n" +
                    ":bilgi - Emulatorinformationen.\n" +
                    ":kaution - Kaution im Knast bezahlen. (2 Dias)\n" +
                    ":user <Habbo> - Einen Habbo aus dem Hotel markieren.\n" +
                    "");



                foreach (var CmdList in _commands.ToList())
                {
                    if (!string.IsNullOrEmpty(CmdList.Value.PermissionRequired))
                    {
                        if (!Session.GetHabbo().GetPermissions().HasCommand(CmdList.Value.PermissionRequired))
                            continue;
                    }

                }

                Session.SendMessage(new MOTDNotificationComposer(List.ToString()));
                return true;
            }

            Message = Message.Substring(1);
            string[] Split = Message.Split(' ');

            if (Split.Length == 0)
                return false;

            if (Session.GetHabbo().Rank == 1)
            {
                this.LogCommand(Session.GetHabbo().Id, Message, Session.GetHabbo().MachineId);
            }
            if (_commands.TryGetValue(Split[0].ToLower(), out IChatCommand Cmd))
            {

                if (Session.GetHabbo().GetPermissions().HasRight("mod_tool"))
                    this.LogCommandStaff(Session.GetHabbo().Id, Message, Session.GetHabbo().MachineId, Session.GetHabbo().Username);

                if (!string.IsNullOrEmpty(Cmd.PermissionRequired))
                {
                    if (!Session.GetHabbo().GetPermissions().HasCommand(Cmd.PermissionRequired))
                        return false;
                }


                Session.GetHabbo().IChatCommand = Cmd;
                Session.GetHabbo().CurrentRoom.GetWired().TriggerEvent(WiredBoxType.TriggerUserSaysCommand, Session.GetHabbo(), this);

                Cmd.Execute(Session, Session.GetHabbo().CurrentRoom, Split);
                return true;
            }
            return false;
        }





        private void RegisterVIP()
        {
            this.Register("spull", new SuperPullCommand());
        }

        private void RegisterEvents()
        {
            this.Register("eha", new EventAlertCommand());

            this.Register("werbung", new PublicityAlertCommand());
            //this.Register("da2", new DiceAlertCommand());
        }

        private void RegisterUser()
        {
            this.Register("komutlar", new BefehleCommand());
            this.Register("etiket", new UserCommand());
    //        this.Register("bilgi", new InfoCommand());
            this.Register("iddia", new IdeeCommand()); //
            this.Register("afk", new AfkCommand());
            this.Register("reklamci", new WerberCommand());
            this.Register("hug", new HugCommand()); // added by Bano //
            this.Register("grupchat", new GroupChatCommand());
            this.Register("roomteleport", new Builder());

            this.Register("pickall", new PickAllCommand());
            this.Register("ejectall", new EjectAllCommand());
            this.Register("yat", new LayCommand());
            this.Register("otur", new SitCommand());
            this.Register("yardim", new HelpCommand());

            this.Register("kalk", new StandCommand());

            this.Register("kuss", new KissCommand());
            this.Register("mutepets", new MutePetsCommand());
            this.Register("mutebots", new MuteBotsCommand());
     //       this.Register("megapush", new BaterCommand()); // added by Bano //
     //       this.Register("megeheal", new CurarCommand());
            this.Register("weed", new WeedCommand());
            this.Register("kopyala", new MimicCommand());
            this.Register("kopya", new MimicCommand());
            this.Register("copy", new MimicCommand());
            this.Register("dans", new DanceCommand());
            this.Register("push", new PushCommand());
            this.Register("pull", new PullCommand());
            this.Register("enable", new EnableCommand()); // added by Bano //
            this.Register("etki", new EnableCommand()); // added by Bano //
            this.Register("takip", new FollowCommand());
            this.Register("faceless", new FacelessCommand());
            this.Register("moonwalk", new MoonwalkCommand());
            this.Register("unload", new UnloadCommand());
            this.Register("fixroom", new RegenMaps());
            this.Register("empty", new EmptyItems());
            this.Register("setmax", new SetMaxCommand());
            this.Register("setspeed", new SetSpeedCommand());
            this.Register("friends", new DisableFriendsCommand());
            this.Register("disablediagonal", new DisableDiagonalCommand());
            this.Register("flagme", new FlagMeCommand());
            this.Register("stats", new StatsCommand());
            this.Register("kickpets", new KickPetsCommand());
            this.Register("kickbots", new KickBotsCommand());
            this.Register("kill", new MatarCommand());
            this.Register("disablegifts", new DisableGiftsCommand());
            this.Register("convertcredits", new ConvertCreditsCommand());
            this.Register("convertduckets", new ConvertDucketsCommand());
            this.Register("disablewhispers", new DisableWhispersCommand());
            this.Register("disablemimic", new DisableMimicCommand()); ;
            this.Register("pet", new PetCommand());
            this.Register("spush", new SuperPushCommand());
            this.Register("superpush", new SuperPushCommand());
            this.Register("eventbox", new GiveSpecialReward());
            this.Register("disableevents", new DisableEventsCommand());
            this.Register("emoji", new EmojiCommand());
            this.Register("odasat", new roomSelllCommand());
            this.Register("odaal", new roomBuyyCommand());
            this.Register("odaredet", new roomDeclineOfferr());
            this.Register("odakabulet", new roomAccepttOffer());
            //   this.Register("heiraten", new HeiratenCommand());
            // this.Register("waffen", new WaffenCommand());
            this.Register("hosgeldin", new WillkommenCommand());
         //   this.Register("seks", new HotCommand());


            //this.Register("color", new ColourCommand());
            this.Register("room", new RoomCommand());
            this.Register("dnd", new DNDCommand());
            //this.Register("sexo", new SexCommand());
      //      this.Register("beijar", new KissCommand());
            //this.Register("emulator", new InfoCommand());
            this.Register("ausrauben", new AusraubenCommand());
            this.Register("disco", new DiscoCommand());
            this.Register("facebook", new FacebookCommand());

        }

        private void RegisterModerator()
        {
            this.Register("spam", new spamCommand());
            this.Register("tazer", new TazerCommand());
            this.Register("kaution", new UnPrisonCommand());
            //this.Register("staffbefehle", new StaffBefehleCommand());
            this.Register("ban", new BanCommand());
            this.Register("unban", new UnBanCommand());
            this.Register("mip", new MIPCommand());
            this.Register("ipban", new IPBanCommand());
            this.Register("wban", new WerberBanCommand());
            this.Register("tag", new PrefixNameCommand());
            this.Register("ui", new UserInfoCommand());
            this.Register("roomgive", new GiveRoomCommand());
            this.Register("staffalert", new StaffAlertCommand());
            this.Register("sa", new SaCommand());
            this.Register("ga", new GuideAlertCommand());
            this.Register("roomunmute", new RoomUnmuteCommand());
            this.Register("roommute", new RoomMuteCommand());
            this.Register("roombadge", new RoomBadgeCommand());
            this.Register("roomalert", new RoomAlertCommand());
            this.Register("roomkick", new RoomKickCommand());
            this.Register("mute", new MuteCommand());
            this.Register("unmute", new UnmuteCommand());
            this.Register("massbadge", new MassBadgeCommand());
            this.Register("massgive", new MassGiveCommand());
            this.Register("kick", new KickCommand());
            this.Register("ha", new HotelAlertCommand());
            this.Register("info", new HaCommand());
            this.Register("hal", new HALCommand());
            this.Register("give", new GiveCommand());
            this.Register("givebadge", new GiveBadgeCommand());
            this.Register("rbadge", new TakeUserBadgeCommand());
            this.Register("dc", new DisconnectCommand());
            this.Register("alert", new AlertCommand());
            this.Register("soru", new PollCommand());
            this.Register("lastmsg", new LastMessagesCommand());
            this.Register("summon", new SummonCommand());
            this.Register("senduser", new SendUserCommand());
            this.Register("override", new OverrideCommand());
            this.Register("massenable", new MassEnableCommand());
            this.Register("massdance", new MassDanceCommand());
            this.Register("dondur", new FreezeCommand());
            this.Register("unfreeze", new UnFreezeCommand());
            this.Register("fastwalk", new FastwalkCommand());
            this.Register("superfastwalk", new SuperFastwalkCommand());
            this.Register("coords", new CoordsCommand());
            this.Register("augenaufmich", new AllEyesOnMeCommand());
            this.Register("ichbinjustinbieberfan", new AllAroundMeCommand());
            this.Register("forcesit", new ForceSitCommand());
            this.Register("soylet", new MakeSayCommand());
            this.Register("flaguser", new FlagUserCommand());
            this.Register("filter", new FilterCommand());
            this.Register("useralert", new UserMessageCommand());
            this.Register("globalmsj", new GlobalMessageCommand());
            this.Register("online", new ViewOnlineCommand());
            this.Register("makepublic", new MakePublicCommand());
            this.Register("makeprivate", new MakePrivateCommand());
            this.Register("customalert", new CustomizedHotelAlert());
            this.Register("kazanan", new PremiarCommand());
            this.Register("ssoru", new EndPollCommand());
            this.Register("polizei", new OfficerCommand());
            this.Register("quiz", new IdolQuizCommand());
            this.Register("prison", new PrisonCommand());
			this.Register("befreien", new UnPrisonCommand());
			this.Register("massspull", new MassSpullCommand());

            //this.Register("userinfo", new UserInfoCommand());
            //this.Register("globalgive", new GlobalGiveCommand());
            //this.Register("tradeban", new TradeBanCommand());
            //this.Register("lastconsolemsg", new LastConsoleMessagesCommand());
            //this.Register("teleport", new TeleportCommand());
            //this.Register("ignorewhispers", new IgnoreWhispersCommand());
            //this.Register("forced_effects", new DisableForcedFXCommand());
            //this.Register("eventbox", new PremiaBonusraros());
            //this.Register("desprender", new UnPrisonCommand());
            //this.Register("darvip", new ReloadUserrVIPRankCommand());
            //this.Register("notifica", new NotificaCommand());
            //this.Register("tagfarbe", new ColourPrefixCommand());
        }

        private void RegisterAdministrator()
        {
            this.Register("rotatebot", new RotateBotCommand());
     //       this.Register("bubble", new BubbleCommand());
            this.Register("bubblebot", new BubbleBotCommand());
            this.Register("update", new UpdateCommand());
            this.Register("emptyuser", new EmptyUser());
            this.Register("deletegroup", new DeleteGroupCommand());
            this.Register("carry", new CarryCommand());
            this.Register("djalert", new DJAlert());
            this.Register("summonall", new SummonAll());
            this.Register("catup", new CatalogUpdateAlert());

            this.Register("megaoferta", new MegaOferta());
            this.Register("cadstaff", new RegisterstaffCommand());
            this.Register("registrastaff", new RegisterstaffCommand());
            this.Register("goto", new GOTOCommand());
            this.Register("staffson", new StaffInfo());
            this.Register("colocapack", new AddPredesignedCommand());
            this.Register("tirapack", new RemovePredesignedCommand());
        }
        /// <summary>
        /// Registers a Chat Command.
        /// </summary>
        /// <param name="CommandText">Text to type for this command.</param>
        /// <param name="Command">The command to execute.</param>
        public void Register(string CommandText, IChatCommand Command)
        {
            this._commands.Add(CommandText, Command);
        }

        public static string MergeParams(string[] Params, int Start)
        {
            var Merged = new StringBuilder();
            for (int i = Start; i < Params.Length; i++)
            {
                if (i > Start)
                    Merged.Append(" ");
                Merged.Append(Params[i]);
            }

            return Merged.ToString();
        }

        public void LogCommand(int UserId, string Data, string MachineId)
        {
            using (IQueryAdapter dbClient = BiosEmuThiago.GetDatabaseManager().GetQueryReactor())
            {
                dbClient.SetQuery("INSERT INTO `logs_client_user` (`user_id`,`data_string`,`machine_id`, `timestamp`) VALUES (@UserId,@Data,@MachineId,@Timestamp)");
                dbClient.AddParameter("UserId", UserId);
                dbClient.AddParameter("Data", Data);
                dbClient.AddParameter("MachineId", MachineId);
                dbClient.AddParameter("Timestamp", BiosEmuThiago.GetUnixTimestamp());
                dbClient.RunQuery();
            }
        }

        public void LogCommandStaff(int UserId, string Data, string MachineId, string Username)
        {
            using (IQueryAdapter dbClient = BiosEmuThiago.GetDatabaseManager().GetQueryReactor())
            {
                dbClient.SetQuery("INSERT INTO `logs_client_staff` (`user_id`,`data_string`,`machine_id`, `timestamp`) VALUES (@UserId,@Data,@MachineId,@Timestamp)");
                dbClient.AddParameter("UserId", UserId);
                dbClient.AddParameter("Data", Data);
                dbClient.AddParameter("MachineId", MachineId);
                dbClient.AddParameter("Timestamp", BiosEmuThiago.GetUnixTimestamp());
                dbClient.RunQuery();
            }

        }

        public bool TryGetCommand(string Command, out IChatCommand IChatCommand)
        {
            return this._commands.TryGetValue(Command, out IChatCommand);
        }
    }
}