﻿using Bios.Core;
using Bios.HabboHotel.GameClients;
using System;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Moderator
{
    class AlertCommand : IChatCommand
    {
        public string PermissionRequired => "command_alert_user";
        public string Parameters => "<Habbo> <Naricht>";
        public string Description => "Eine Alert an einen Habbo verschicken.";

        public void Execute(GameClients.GameClient Session, Rooms.Room Room, string[] Params)
        {
          
            if (Params.Length == 1)
            {
                Session.SendWhisper("Bitte gib einen Habbonamen sowie eine Naricht ein (:alert <Habbo> <Naricht>).");
                return;
            }

            GameClient TargetClient = BiosEmuThiago.GetGame().GetClientManager().GetClientByUsername(Params[1]);
            if (TargetClient == null)
            {
                Session.SendWhisper("Dieser Habbo konnte nicht gefundenw werden.");
                return;
            }

            if (TargetClient.GetHabbo() == null)
            {
                Session.SendWhisper("Dieser Habbo konnte nicht gefunden werden.");
                return;
            }
            
            if (TargetClient.GetHabbo().Username == Session.GetHabbo().Username)
            {
                Session.SendWhisper("Sehr witzig.");
                return;
            }

            string Message = CommandManager.MergeParams(Params, 2);

            TargetClient.SendNotification(Session.GetHabbo().Username + " schrieb dir:\n\n" + Message);
            Session.SendWhisper("Alert wurd erfolgreich an " + TargetClient.GetHabbo().Username + " verschickt!");

        }
    }
}
