﻿using System;
using Bios.HabboHotel.Users;
using Bios.HabboHotel.GameClients;
using Bios.HabboHotel.Moderation;
using Bios.Database.Interfaces;
using Bios.Communication.Packets.Outgoing.Moderation;
using Bios.Communication.Packets.Outgoing.Rooms.Chat;
using Bios.Core;
using Bios.Communication.Packets.Outgoing.Rooms.Notifications;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Moderator
{
    class BanCommand : IChatCommand
    {

        public string PermissionRequired => "command_ban";
        public string Parameters => "<Habbo> <Dauer> <Grund>";
        public string Description => "Einen Habbo aus dem Hotel verbannen.";

        public void Execute(GameClients.GameClient Session, Rooms.Room Room, string[] Params)
        {
        
            if (Params.Length == 1)
            {
                Session.SendWhisper("Bitte gib folgendes ein (:ban <Habbo> <Dauer> <Grund>).");
                return;
            }

            Habbo Habbo = BiosEmuThiago.GetHabboByUsername(Params[1]);
            if (Habbo == null)
            {
                Session.SendWhisper("Dieser Habbo konnte nicht gefunden werden.");
                return;
            }

            if (Habbo.GetPermissions().HasRight("mod_soft_ban") && !Session.GetHabbo().GetPermissions().HasRight("mod_ban_any"))
            {
                Session.SendWhisper("Du kannst diesen Habbo nicht bannen.");
                return;
            }

            Double Expire = 0;
            string Hours = Params[2];
            if (String.IsNullOrEmpty(Hours) || Hours == "perm")
                Expire = BiosEmuThiago.GetUnixTimestamp() + 78892200;
            else
                Expire = (BiosEmuThiago.GetUnixTimestamp() + (Convert.ToDouble(Hours) * 3600));

            string Reason = null;
            if (Params.Length >= 4)
                Reason = CommandManager.MergeParams(Params, 3);
            else
                Reason = "Kein Grund angegeben.";

            string Username = Habbo.Username;
            using (IQueryAdapter dbClient = BiosEmuThiago.GetDatabaseManager().GetQueryReactor())
            {
                dbClient.runFastQuery("UPDATE `user_info` SET `bans` = `bans` + '1' WHERE `user_id` = '" + Habbo.Id + "' LIMIT 1");
            }

            BiosEmuThiago.GetGame().GetModerationManager().BanUser(Session.GetHabbo().Username, ModerationBanType.USERNAME, Habbo.Username, Reason, Expire);

            GameClient TargetClient = BiosEmuThiago.GetGame().GetClientManager().GetClientByUsername(Username);
            if (TargetClient != null)
                TargetClient.Disconnect();

            else
                

            Session.SendWhisper("'" + Username + "' wurde für " + Hours + " Stunden aus folgendem Grund gebannt: '" + Reason + "'!");
            BiosEmuThiago.GetGame().GetClientManager().StaffAlert(new WhisperComposer(1, "" + Session.GetHabbo().Username + " hat '" + Username + "' für " + Hours + " Stunden aus folgendem Grund gebannt: '" + Reason + "'!", 0, 1));

        }
    }
}