﻿using Bios.Core;
using Bios.HabboHotel.GameClients;
using System;
using System.Data;
using System.Collections.Generic;
using Bios.Communication.Packets.Outgoing.Users;
using Bios.Communication.Packets.Outgoing.Notifications;
using Bios.Communication.Packets.Outgoing.Handshake;
using Bios.Communication.Packets.Outgoing.Quests;
using Bios.HabboHotel.Items;
using Bios.Communication.Packets.Outgoing.Inventory.Furni;
using Bios.Communication.Packets.Outgoing.Catalog;
using Bios.HabboHotel.Quests;
using Bios.HabboHotel.Rooms;
using Bios.Communication.Packets.Outgoing.Rooms.Chat;
using System.Threading;


using Bios.Communication.Packets.Outgoing.Rooms.Avatar;
using Bios.Communication.Packets.Outgoing.Pets;
using Bios.Communication.Packets.Outgoing.Messenger;
using Bios.HabboHotel.Users.Messenger;
using Bios.Communication.Packets.Outgoing.Rooms.Polls;
using Bios.Communication.Packets.Outgoing.Rooms.Notifications;
using Bios.Communication.Packets.Outgoing.Availability;
using Bios.Communication.Packets.Outgoing;
using Bios.Database.Interfaces;



namespace Bios.HabboHotel.Rooms.Chat.Commands.Moderator
{
    class DisconnectCommand : IChatCommand
    {
        public string PermissionRequired => "command_disconnect";
        public string Parameters => "<Habbo>";
        public string Description => "Einen Habbo aus den Clienten werfen.";

        public void Execute(GameClients.GameClient Session, Rooms.Room Room, string[] Params)
        {
        

            if (Params.Length == 1)
            {
                Session.SendWhisper("Bitte gib einen Habbonamen ein (:dc <Habbo>).");
                return;
            }

            GameClient TargetClient = BiosEmuThiago.GetGame().GetClientManager().GetClientByUsername(Params[1]);
            if (TargetClient == null)
            {
                Session.SendWhisper("Dieser Habbo konnte nicht gefunden werden.");
                return;
            }

            if (TargetClient.GetHabbo().Rank >= Session.GetHabbo().Rank)
            {
                Session.SendWhisper("Du kannst diesen Habbo nicht aus den Clienten werfen.");
                return;
            }

            if (TargetClient.GetHabbo().GetPermissions().HasRight("mod_tool") && !Session.GetHabbo().GetPermissions().HasRight("mod_disconnect_any"))
            {
                Session.SendWhisper("Du kannst diesen Habbo nicht aus den Clienten werfen.");
                return;
            }

            TargetClient.GetConnection().Dispose();
            BiosEmuThiago.GetGame().GetClientManager().StaffAlert(new WhisperComposer(1, "IosSystem: " + Session.GetHabbo().Username + " hat " + TargetClient.GetHabbo().Username + " aus dem Client geworfen.", 0, 1));
        }
    }
}