﻿using Bios.Core;
using Bios.Database.Interfaces;
using System;
using Bios.Communication.Packets.Outgoing.Moderation;
using Bios.Communication.Packets.Outgoing.Rooms.Notifications;
using Bios.Communication.Packets.Outgoing.Rooms.Chat;
namespace Bios.HabboHotel.Rooms.Chat.Commands.Moderator
{
    class FilterCommand : IChatCommand
    {

        public string PermissionRequired => "command_filter";
        public string Parameters => "<Wort>";
        public string Description => "Ein Wort in den Filter hinzufügen.";

        public void Execute(GameClients.GameClient Session, Rooms.Room Room, string[] Params)
        {
          

            if (Params.Length == 1)
            {
                Session.SendWhisper("Bitte gib ein Wort ein (:filter <Wort>).");
                return;
            }

            using (IQueryAdapter dbClient = BiosEmuThiago.GetDatabaseManager().GetQueryReactor())
            {
                dbClient.runFastQuery("INSERT INTO `wordfilter` (id, word, replacement, strict, addedby, bannable) VALUES (NULL, '" + Params[1] + "', '" + BiosEmuThiago.HotelName + "', '1', '" + Session.GetHabbo().Username + "', '0')");
            }

            BiosEmuThiago.GetGame().GetChatManager().GetFilter().InitWords();
            BiosEmuThiago.GetGame().GetChatManager().GetFilter().InitCharacters();
            Session.SendWhisper("Das Wort wurde erfolgreich zur Filterliste hinzugefügt.");
            BiosEmuThiago.GetGame().GetClientManager().StaffAlert(new WhisperComposer(1, "@red@IosSystem: " + Session.GetHabbo().Username + " hat folgendes Wort zur Filterliste hinzugefügt: " + Params[1] + "", 0, 1));
        }
    }
}