﻿using Bios.HabboHotel.GameClients;
using Bios.Communication.Packets.Outgoing.Handshake;
using Bios.Core;
using System;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Moderator
{
    class FlagUserCommand : IChatCommand
    {
        public string PermissionRequired => "command_flaguser";
        public string Parameters => "<Habbo>";
        public string Description => "Den Namen eines anderen Xubbo ändern.";

        public void Execute(GameClients.GameClient Session, Rooms.Room Room, string[] Params)
        {
         
            if (Params.Length == 1)
            {
                Session.SendWhisper("Bitte gib einen Xubbonamen ein (:flaguser <Habbo>).");
                return;
            }

            GameClient TargetClient = BiosEmuThiago.GetGame().GetClientManager().GetClientByUsername(Params[1]);
            if (TargetClient == null)
            {
                Session.SendWhisper("Dieser Xubbo konnte nicht gefunden werden.");
                return;
            }

            if (TargetClient.GetHabbo().GetPermissions().HasRight("mod_tool"))
            {
                Session.SendWhisper("Du kannst das nicht bei dem Xubbo machen. HIHI.");
                return;
            }
            else
            {
                TargetClient.GetHabbo().LastNameChange = 0;
                TargetClient.GetHabbo().ChangingName = true;
                TargetClient.SendNotification("\r\rKlicke auf den Xubbo, um den Namen zu ändern!");
                TargetClient.SendMessage(new UserObjectComposer(TargetClient.GetHabbo()));
            }

        }
    }
}
