﻿using Bios.Communication.Packets.Outgoing.Rooms.Chat;
using Bios.HabboHotel.Items.Wired;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Moderator.Fun
{
    class MakeSayCommand : IChatCommand
    {
        public string PermissionRequired => "command_makesay";
        public string Parameters => "<Habbo> <Naricht>";
        public string Description => "Den Chat eines anderen Habbos kontrollieren.";

        public void Execute(GameClients.GameClient Session, Rooms.Room Room, string[] Params)
        {
            
            RoomUser ThisUser = Room.GetRoomUserManager().GetRoomUserByHabbo(Session.GetHabbo().Id);
            if (ThisUser == null)
                return;

            if (Params.Length == 1)
                Session.SendWhisper("Bitte gib einen Habbonamen sowie eine Naricht ein (:makesay <Habbo> <Naricht>).");
            else
            {
                string Message = CommandManager.MergeParams(Params, 2);
                RoomUser TargetUser = Session.GetHabbo().CurrentRoom.GetRoomUserManager().GetRoomUserByHabbo(Params[1]);
                if (TargetUser != null)
                {
                    if (TargetUser.GetClient() != null && TargetUser.GetClient().GetHabbo() != null)
                        if (!TargetUser.GetClient().GetHabbo().GetPermissions().HasRight("mod_make_say_any"))
                        {
                            Room.SendMessage(new ChatComposer(TargetUser.VirtualId, Message, 0, TargetUser.LastBubble));
                            Room.GetWired().TriggerEvent(WiredBoxType.TriggerUserSaysCommand, Session.GetHabbo(), Message);
                            Room.GetWired().TriggerEvent(WiredBoxType.TriggerUserSays, Session.GetHabbo(), Message);
                        }
                        else
                        {
                            Session.SendWhisper("Du kannst das nicht bei dem Habbo machen. Hihi");
                        }
                }
                else
                    Session.SendWhisper("Der Habbo konnte nicht gefunden werden.");
            }
        }
    }
}
