﻿using System.Linq;
using System.Collections.Generic;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Moderator.Fun
{
    class MassEnableCommand : IChatCommand
    {
        public string PermissionRequired => "command_massenable";
        public string Parameters => "<Effekt-ID>";
        public string Description => "Jedem im Raum den gleichen Effekt geben.";

        public void Execute(GameClients.GameClient Session, Room Room, string[] Params)
        {
            
            if (Params.Length == 1)
            {
                Session.SendWhisper("Bitte gib einen Effekt-ID ein (:massenable <Effekt-ID>).");
                return;
            }

            int EnableId = 0;
            if (int.TryParse(Params[1], out EnableId))
            {
                if ((EnableId == 102 || EnableId == 187) && !Session.GetHabbo().GetPermissions().HasRight("mod_tool"))
                {
                    Session.SendWhisper("Nur Mitarbeiter können diesen Effekt nutzen.");
                    return;
                }

                if (EnableId == 178 && (!Session.GetHabbo().GetPermissions().HasRight("gold_vip") && !Session.GetHabbo().GetPermissions().HasRight("events_staff")))
                {
                    Session.SendWhisper("Nur Mitarbeiter können diesen Effekt nutzen.");
                    return;
                }

                if (!Session.GetHabbo().GetPermissions().HasCommand("command_override_massenable") && Room.OwnerId != Session.GetHabbo().Id)
                {
                    Session.SendWhisper("Du kannst diesen Befehl nur in deinem eigenem Raum nutzen.");
                    return;
                }

                List<RoomUser> Users = Room.GetRoomUserManager().GetRoomUsers();
                if (Users.Count > 0)
                {
                    foreach (RoomUser U in Users.ToList())
                    {
                        if (U == null || U.RidingHorse)
                            continue;

                        U.ApplyEffect(EnableId);
                    }
                }
            }
            else
            {
                Session.SendWhisper("Ungültige Eingabe, bitte nur Zahlen.");
                return;
            }
        }
    }
}
