﻿using Bios.HabboHotel.GameClients;
using Bios.Communication.Packets.Outgoing.Rooms.Session;
using Bios.Communication.Packets.Outgoing.Rooms.Notifications;
using Bios.Communication.Packets.Outgoing;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Moderator.Fun
{
    class SendUserCommand : IChatCommand
    {
        public string PermissionRequired => "command_summon";
        public string Parameters => "<Habbo> <Raum-ID>";
        public string Description => "Einen Habbo in einen bestimmten Raum teleportieren.";

        public void Execute(GameClients.GameClient Session, Rooms.Room Room, string[] Params)
        {
            
            if (Params.Length == 2)
            {
                Session.SendWhisper("Bitte gib einen Habbonamen sowie ein Raum-ID ein (:senduser <Habbo> <Raum-ID>).");
                return;
            }

            GameClient TargetClient = BiosEmuThiago.GetGame().GetClientManager().GetClientByUsername(Params[1]);
            if (TargetClient == null)
            {
                Session.SendWhisper("Dieser Habbo konnte nicht gefunden werden.");
                return;
            }
            
            
            if (TargetClient.GetHabbo() == null)
            {
                Session.SendWhisper("Dieser Habbo konnte nicht gefunden werden.");
                return;
            }

            if (TargetClient.GetHabbo().Username == Session.GetHabbo().Username)
            {
                Session.SendWhisper("Sehr witzig.");
                return;
            }

            int RoomID;
            if (!int.TryParse(Params[2], out RoomID))
            {
                Session.SendWhisper("Ungültige Eingabe (:senduser <Habbo> <Raum-ID>).");
                return;
            }

            if (!BiosEmuThiago.GetGame().GetRoomManager().RoomExist(RoomID))
            {
                Session.SendWhisper("Der Raum existiert wahrscheinlich nicht.");
                return;

            }
            RoomData RoomData = BiosEmuThiago.GetGame().GetRoomManager().GenerateRoomData(RoomID);
            //TargetClient.SendNotification("Has sido enviado a la sala " + RoomData.Name + "!");
            TargetClient.SendMessage(RoomNotificationComposer.SendBubble("advice", "Du wurdest in Raum: " + RoomData.Name + " teleportiert!", ""));
            if (!TargetClient.GetHabbo().InRoom)
                TargetClient.SendMessage(new RoomForwardComposer(RoomID));
            else
                TargetClient.GetHabbo().PrepareRoom(RoomID, "");
        }
    }
}