﻿using Bios.HabboHotel.GameClients;
using Bios.Communication.Packets.Outgoing.Rooms.Chat;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Moderator.Fun
{
    class UnFreezeCommand : IChatCommand
    {
        public string PermissionRequired => "command_unfreeze";
        public string Parameters => "<Habbo>";
        public string Description => "Einen Habbo auftauen..";

        public void Execute(GameClients.GameClient Session, Rooms.Room Room, string[] Params)
        {
            

            if (Params.Length == 1)
            {
                Session.SendWhisper("Bitte gib einen Habbonamen ein (:unfreeze <Habbo>).");
                return;
            }

            GameClient TargetClient = BiosEmuThiago.GetGame().GetClientManager().GetClientByUsername(Params[1]);
            if (TargetClient == null)
            {
                Session.SendWhisper("Dieser Habbo konnte nicht gefunden werden.");
                return;
            }

            RoomUser TargetUser = Session.GetHabbo().CurrentRoom.GetRoomUserManager().GetRoomUserByHabbo(Params[1]);
            if (TargetUser != null)
                TargetUser.Frozen = false;
            TargetUser.ApplyEffect(920);

            RoomUser TargetID = Room.GetRoomUserManager().GetRoomUserByHabbo(TargetClient.GetHabbo().Id);
            RoomUser User = Room.GetRoomUserManager().GetRoomUserByHabbo(Session.GetHabbo().Id);

            if (TargetClient.GetHabbo().Username == Session.GetHabbo().Username)
            {
                Session.SendWhisper("Du wurdest aufgetaut. Du kannst dich jetzt wieder bewegen.");
                Room.SendMessage(new ChatComposer(User.VirtualId, "*Wurde gerade von einem Mitarbeiter aufgetaut*", 0, 1));
                return;
            }
        }
    }
}
