﻿using System.Linq;
using Bios.Communication.Packets.Outgoing.Inventory.Purse;
using Bios.Communication.Packets.Outgoing.Rooms.Notifications;
using Bios.HabboHotel.GameClients;
using System.Text;
using Bios.Communication.Packets.Outgoing.Notifications;
using Bios.Core;
using System;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Moderator
{
    class MassGiveCommand : IChatCommand
    {
        public string PermissionRequired => "command_mass_give";
        public string Parameters => "<Währung> <Menge>";
        public string Description => "Jeden im Hotel Taler/Duckets/Diamanten o.Ä. vergeben.";

        public void Execute(GameClient Session, Room room, string[] Params)
        {

            var updateVal = Params[1];
            switch (updateVal.ToLower())
            {
                case "taler":
                case "credits":
                    {
                        if (!Session.GetHabbo().GetPermissions().HasCommand("command_give_coins"))
                        {
                            Session.SendWhisper("Sen Staff degilsin.");
                            break;
                        }
                        int amount;
                        if (int.TryParse(Params[2], out amount))
                        {
                            foreach (var client in BiosEmuThiago.GetGame().GetClientManager().GetClients.ToList().Where(client => client?.GetHabbo() != null && client.GetHabbo().Username != Session.GetHabbo().Username))
                            {
                                client.GetHabbo().Credits = client.GetHabbo().Credits += amount;
                                client.SendMessage(new CreditBalanceComposer(client.GetHabbo().Credits));

                                 client.SendMessage(new RoomNotificationComposer("command_notification_credits", "message", " " + Session.GetHabbo().Username + " hoteldeki herkese " + amount + " kredi verdi!"));
                            }

                            break;
                        }
                        Session.SendWhisper("Gecersiz giis.");
                        break;
                    }

                case "pixels":
                case "duckets":
                    {
                        if (!Session.GetHabbo().GetPermissions().HasCommand("command_give_pixels"))
                        {
                            Session.SendWhisper("Du bist kein Mitarbeiter.");
                            break;
                        }
                        int amount;
                        if (int.TryParse(Params[2], out amount))
                        {
                            foreach (var client in BiosEmuThiago.GetGame().GetClientManager().GetClients.ToList().Where(client => client?.GetHabbo() != null && client.GetHabbo().Username != Session.GetHabbo().Username))
                            {
                                client.GetHabbo().Duckets += amount;
                                client.SendMessage(new HabboActivityPointNotificationComposer(
                                    client.GetHabbo().Duckets, amount));

                                client.SendMessage(new RoomNotificationComposer("command_notification_credits", "message", "" + Session.GetHabbo().Username + " hoteldeki herkese " + amount + " ördek verdi!"));
                            }
                            break;
                        }
                        Session.SendWhisper("Ungültige Eingabe.");
                        break;
                    }

                case "diamonds":
                case "diamanten":
                    {
                        if (!Session.GetHabbo().GetPermissions().HasCommand("command_give_diamonds"))
                        {
                            Session.SendWhisper("Du bist kein Mitarbeiter.");
                            break;
                        }
                        int amount;
                        if (int.TryParse(Params[2], out amount))
                        {
                            foreach (var client in BiosEmuThiago.GetGame().GetClientManager().GetClients.ToList().Where(client => client?.GetHabbo() != null && client.GetHabbo().Username != Session.GetHabbo().Username))
                            {
                                client.GetHabbo().Diamonds += amount;
                                client.SendMessage(new HabboActivityPointNotificationComposer(client.GetHabbo().Diamonds,
                                    amount,
                                    5));

                                client.SendMessage(new RoomNotificationComposer("command_notification_credits", "message", "" + Session.GetHabbo().Username + " hoteldeki herkese " + amount + " elmas verdi!"));
                            }

                            break;
                        }
                        Session.SendWhisper("Ungültige Eingabe.");
                        break;
                    }

                case "gotws":
                case "gotw":
                case "gotwpoints":
                case "fame":
                case "fama":
                case "ptf":
                case "famepoints":
                    {
                        if (!Session.GetHabbo().GetPermissions().HasCommand("command_give_gotw"))
                        {
                            Session.SendWhisper("DU bist kein Mitarbeiter.");
                            break;
                        }
                        int Amount;
                        if (int.TryParse(Params[2], out Amount))
                        {
                            if (Amount > 50)
                            {
                                Session.SendWhisper("Du kannst nicht mehr als 50 Eventpunkte verschicken.");
                                return;
                            }

                            foreach (GameClient Target in BiosEmuThiago.GetGame().GetClientManager().GetClients.ToList())
                            {
                                if (Target == null || Target.GetHabbo() == null || Target.GetHabbo().Username == Session.GetHabbo().Username)
                                    continue;

                                Target.GetHabbo().GOTWPoints = Target.GetHabbo().GOTWPoints + Amount;
                                Target.GetHabbo().UserPoints = Target.GetHabbo().UserPoints + 1;
                                Target.SendMessage(new HabboActivityPointNotificationComposer(Target.GetHabbo().GOTWPoints, Amount, 103));

                                if (Target.GetHabbo().Id != Session.GetHabbo().Id)
                                    Target.SendMessage(RoomNotificationComposer.SendBubble("command_notification_credits", "" + Session.GetHabbo().Username + " hat dir " + Amount + " " + Core.ExtraSettings.PTOS_COINS + " gutgeschrieben.", "")); 
                            }

                            break;
                        }
                        else
                        {
                            Session.SendWhisper("Ungültige Eingabe.");
                            break;
                        }
                    }
                case "gotwt":
                case "gotwpointst":
                case "famet":
                case "famat":
                case "ptft":
                case "famepointst":
                    {
                        if (!Session.GetHabbo().GetPermissions().HasCommand("command_give_gotw"))
                        {
                            Session.SendWhisper("Wow, es sieht so aus, als hätten Sie nicht die notwendigen Berechtigungen, um diesen Befehl zu benutzen!");
                            break;
                        }
                        int amount;
                        if (int.TryParse(Params[2], out amount))
                        {
                            foreach (var client in BiosEmuThiago.GetGame().GetClientManager().GetClients.ToList().Where(client => client?.GetHabbo() != null && client.GetHabbo().Username != Session.GetHabbo().Username))
                            {
                                client.GetHabbo().GOTWPoints = client.GetHabbo().GOTWPoints + amount;
                                client.SendMessage(new HabboActivityPointNotificationComposer(client.GetHabbo().GOTWPoints,
                                    amount, 103));

                                client.SendMessage(new RoomNotificationComposer("command_notification_credits", "message", "Recebeu " + amount + " " + Core.ExtraSettings.PTOS_COINS + " de " + Session.GetHabbo().Username + "!"));
                            }
                            break;
                        }
                        Session.SendWhisper("Uau, isso scheint ein ungültiger Wert zu sein!");
                        break;
                    }
                default:
                    Session.SendWhisper("'" + updateVal + "' ist keine gültige Währung.");
                    break;
            }
        }
    }
}