﻿using System;
using Bios.Communication.Packets.Outgoing.Moderation;
using Bios.HabboHotel.GameClients;
using Bios.Core;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Moderator
{
    class TakeUserBadgeCommand : IChatCommand
    {
        public string PermissionRequired => "command_give_badge"; 
        public string Parameters => "<Habbo> <Badge-ID>";
        public string Description => "Ein Badge von einem Habbo entfernen.";

        public void Execute(GameClient Session, Room Room, string[] Params)
        {
            if (Params.Length != 3)
            {
                Session.SendWhisper("Bitte gib einen Habbonamen sowie eine Badge-ID ein (:rbadge <Habbo> <Badge-ID>).");
                return;
            }

            GameClient client = BiosEmuThiago.GetGame().GetClientManager().GetClientByUsername(Params[1]);
            if (client == null || client.GetHabbo() == null)
                return;

            if (string.IsNullOrEmpty(Convert.ToString(Params[2])))
                return;

            string badge = Convert.ToString(Params[2]);

            if (client.GetHabbo().GetBadgeComponent().HasBadge(badge))
            {
                client.GetHabbo().GetBadgeComponent().RemoveBadge(badge);
                Session.SendMessage(new BroadcastMessageAlertComposer(BiosEmuThiago.GetGame().GetLanguageManager().TryGetValue("server.console.alert") + "\n\n" + "O emblema <b>"+ badge + " foi removido de "+ client.GetHabbo().Username+" com exito!"));
            }
            return;
        }
    }
}