﻿
using Bios.Core;
using Bios.Database.Interfaces;
using Bios.HabboHotel.GameClients;
using System;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Moderator
{
	class UnmuteCommand : IChatCommand
	{
		public string PermissionRequired
		{
			get { return "command_unmute"; }
		}

		public string Parameters
		{
			get { return "<Habbo>"; }
		}

		public string Description
		{
			get { return "Die Stummschaltung eines Habbos aufheben."; }
		}

		public void Execute(GameClients.GameClient Session, Rooms.Room Room, string[] Params)
		{
            if (Params.Length == 1)
			{
				Session.SendWhisper("Bitte gib einen Habbonamen ein (:unmute <Habbo>).");
				return;
			}

			GameClient TargetClient = BiosEmuThiago.GetGame().GetClientManager().GetClientByUsername(Params[1]);
			if (TargetClient == null || TargetClient.GetHabbo() == null)
			{
				Session.SendWhisper("Dieser Habbo konnte nicht gefunden werden.");
				return;
			}

			using (IQueryAdapter dbClient = BiosEmuThiago.GetDatabaseManager().GetQueryReactor())
			{
				dbClient.RunQuery("UPDATE `users` SET `time_muted` = '0' WHERE `id` = '" + TargetClient.GetHabbo().Id + "' LIMIT 1");
			}

			TargetClient.GetHabbo().TimeMuted = 0;
			TargetClient.SendNotification("Die Stummschaltung wurde von " + Session.GetHabbo().Username + " aufgehoben!");
			Session.SendWhisper("Du hast die Stummschaltung bei " + TargetClient.GetHabbo().Username + " aufgehoben!");
		}
	}
}