﻿using System;
using System.Linq;
using System.Text;
using System.Collections.Generic;



using Bios.HabboHotel.Users;

using Bios.Communication.Packets.Outgoing.Notifications;
using Bios.Core;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Moderator
{
    class ViewOnlineCommand : IChatCommand
    {
        public string PermissionRequired => "command_view_online";
        public string Parameters => "";
        public string Description => "Zeigt alle aktuellen Spieler an, die online sind.";

        public void Execute(GameClients.GameClient Session, Rooms.Room Room, string[] Params)
        {
            Dictionary<Habbo, UInt32> clients = new Dictionary<Habbo, UInt32>();

            StringBuilder content = new StringBuilder();
            content.Append("- ONLINE SPIELER -\r\n");

            foreach (var client in BiosEmuThiago.GetGame().GetClientManager().GetClients.ToList())
            {
                if (client == null)
                    continue;

                content.Append("¥ " + client.GetHabbo().Username + " » Raum: " + ((client.GetHabbo().CurrentRoom == null) ? "Befindet sich in keinem Raum." : client.GetHabbo().CurrentRoom.RoomData.Name) + "\r\n");
            }

            Session.SendMessage(new MOTDNotificationComposer(content.ToString()));
            return;
        }
    }
}
