﻿using Bios.HabboHotel.Users;
using Bios.HabboHotel.GameClients;
using Bios.HabboHotel.Moderation;
using Bios.Database.Interfaces;
using Bios.Core;
using System;

using Bios.Communication.Packets.Outgoing.Inventory.Furni;
using Bios.Communication.Packets.Outgoing.Catalog;
using Bios.HabboHotel.Quests;

using Bios.Communication.Packets.Outgoing.Rooms.Chat;
using System.Threading;

using Bios.Communication.Packets.Outgoing.Rooms.Avatar;
using Bios.Communication.Packets.Outgoing.Pets;
using Bios.Communication.Packets.Outgoing.Messenger;
using Bios.HabboHotel.Users.Messenger;
using Bios.Communication.Packets.Outgoing.Rooms.Polls;
using Bios.Communication.Packets.Outgoing.Rooms.Notifications;
using Bios.Communication.Packets.Outgoing.Availability;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Moderator
{
    class WerberBanCommand : IChatCommand
    {

        public string PermissionRequired => "command_ban";
        public string Parameters => "<Habbo>";
        public string Description => "Einen Werber bannen.";

        public void Execute(GameClients.GameClient Session, Rooms.Room Room, string[] Params)
        {
            if (Params.Length == 1)
            {
                Session.SendWhisper("Bitte gib einen Habbonamen ein (:wban <Habbo>).");
                return;
            }

            Habbo Habbo = BiosEmuThiago.GetHabboByUsername(Params[1]);
            if (Habbo == null)
            {
                Session.SendWhisper("Dieser Habbo konnte nicht gefunden werden.");
                return;
            }

            if (Habbo.GetPermissions().HasRight("mod_soft_ban") && !Session.GetHabbo().GetPermissions().HasRight("mod_ban_any"))
            {
                Session.SendWhisper("Dieser Habbo kann nicht gebannt werden.");
                return;
            }
            int time = 1576108800;
            string Reason = "[WBAN] Werber";
            string Username = Habbo.Username;
            using (IQueryAdapter dbClient = BiosEmuThiago.GetDatabaseManager().GetQueryReactor())
            {
                dbClient.runFastQuery("UPDATE `user_info` SET `bans` = `bans` + '1' WHERE `user_id` = '" + Habbo.Id + "' LIMIT 1");
            }

            BiosEmuThiago.GetGame().GetModerationManager().BanUser(Session.GetHabbo().Username, ModerationBanType.USERNAME, Habbo.Username, Reason, time);

            GameClient TargetClient = BiosEmuThiago.GetGame().GetClientManager().GetClientByUsername(Username);
            if (TargetClient != null)
                TargetClient.Disconnect();

            Session.SendWhisper("'" + Username + "'  wurde durch 'Werben' gebannt.");
            BiosEmuThiago.GetGame().GetClientManager().StaffAlert(new WhisperComposer(1, "@red@IosSystem: " + Session.GetHabbo().Username + " hat " + Username + " wegen 'Werben' gebannt.", 0, 1));
        }
    }
}