﻿using Bios.HabboHotel.Users;
using Bios.Communication.Packets.Outgoing.Handshake;

namespace Bios.HabboHotel.Rooms.Chat.Commands.User
{
    class FlagMeCommand : IChatCommand
    {
        public string PermissionRequired => "command_flagme";
        public string Parameters => "";
        public string Description => "Seinen Habbonamen ändern.";

        public void Execute(GameClients.GameClient Session, Rooms.Room Room, string[] Params)
        {
            
            if (!this.CanChangeName(Session.GetHabbo()))
            {
                Session.SendWhisper("Adını şimdi değiştiremezsin.");
                return;
            }

            Session.GetHabbo().ChangingName = true;
            Session.SendNotification("<b><font size='15px' color='#3498db'>Isim Degistir!<br></font></b>\nUygunsuz bir isim olması durumunda, 5 uyarı ve ardından yasağı içeren bir uyarı alacaksınız. Sadece bir kez ismini değiştirebilirsin, ikinci kez değil.\r <i>Bunu kapattiktan sonra Kabbo avatariniza tiklayin, ve isminizi degistirin!</i>");
            Session.SendMessage(new UserObjectComposer(Session.GetHabbo()));
        }

        private bool CanChangeName(Habbo Habbo)
        {
            if (Habbo.Rank == 1 && Habbo.VIPRank == 0 && Habbo.LastNameChange == 0)
                return true;
            else if (Habbo.Rank == 1 && Habbo.VIPRank == 1 && (Habbo.LastNameChange == 0 || (BiosEmuThiago.GetUnixTimestamp() + 604800) > Habbo.LastNameChange))
                return true;
            else if (Habbo.Rank == 1 && Habbo.VIPRank == 2 && (Habbo.LastNameChange == 0 || (BiosEmuThiago.GetUnixTimestamp() + 86400) > Habbo.LastNameChange))
                return true;
            else if (Habbo.Rank == 1 && Habbo.VIPRank == 3)
                return true;
            else if (Habbo.GetPermissions().HasRight("mod_tool"))
                return true;

            return false;
        }
    }
}
