﻿using Bios.HabboHotel.GameClients;

namespace Bios.HabboHotel.Rooms.Chat.Commands.User.Fun
{
    class FollowCommand : IChatCommand
    {
        public string PermissionRequired => "command_follow";
        public string Parameters => "<Habbo>"; 
        public string Description => "Einen Habbo folgen.";

        public void Execute(GameClient Session, Room Room, string[] Params)
        {
            

            if (Params.Length == 1)
            {
                Session.SendWhisper("Bitte gib einen Habbonamen ein (:folgen <Habbo>).");
                return;
            }

            GameClient TargetClient = BiosEmuThiago.GetGame().GetClientManager().GetClientByUsername(Params[1]);
            if (TargetClient == null)
            {
                Session.SendWhisper("Der Habbo konnte nicht gefunden werden.");
                return;
            }

            if (TargetClient.GetHabbo().CurrentRoom == Session.GetHabbo().CurrentRoom)
            {
                Session.SendWhisper("" + TargetClient.GetHabbo().Username + " befindet sich bereits in deinem Raum!");
                return;
            }

            if (TargetClient.GetHabbo().Username == Session.GetHabbo().Username)
            {
                Session.SendWhisper("Sehr witzig. Added by Bano");
                return;
            }

            if (!TargetClient.GetHabbo().InRoom)
            {
                Session.SendWhisper("Dieser Habbo befindet sich auf der Hotelansicht.");
                return;
            }

            if (TargetClient.GetHabbo().CurrentRoom.Access != RoomAccess.OPEN && !Session.GetHabbo().GetPermissions().HasRight("mod_tool"))
            {
                Session.SendWhisper("Der Habbo befindet sich in einem Raum, welcher abgeschlossen ist.");
                return;
            }
            TargetClient.SendWhisper(Session.GetHabbo().Username + " ist dir in deinen Raum gefolgt.");
            Session.GetHabbo().PrepareRoom(TargetClient.GetHabbo().CurrentRoom.RoomId, "");
        }
    }
}
