﻿using System;
using Bios.HabboHotel.GameClients;
using Bios.Communication.Packets.Outgoing.Rooms.Chat;


namespace Bios.HabboHotel.Rooms.Chat.Commands.User.Fun
{
    class HugCommand : IChatCommand
    {
        public string PermissionRequired => "command_kiss";
        public string Parameters => "<Habbo>";
        public string Description => "Einen Habbo umarmen.";

        public void Execute(GameClient Session, Room Room, string[] Params)
        {
            if (Params.Length == 1)
            {
                Session.SendWhisper("Lutfen bir habbo ismi girin (:hug <Habbo>).");
                return;
            }
            GameClient Target = BiosEmuThiago.GetGame().GetClientManager().GetClientByUsername(Params[1]);
            if (Target == null)
            {
                Session.SendWhisper("Bu Habbo suanda bulunamiyor.");
                return;
            }
            else
            {
                RoomUser TargetID = Room.GetRoomUserManager().GetRoomUserByHabbo(Target.GetHabbo().Id);
                RoomUser User = Room.GetRoomUserManager().GetRoomUserByHabbo(Session.GetHabbo().Id);
                if (TargetID == null)
                {
                    Session.LogsNotif("Der Habbo konnte nicht gefunden werden.", "command_notification");
                    return;
                }
                else if (Target.GetHabbo().Username == Session.GetHabbo().Username)
                {
                    Session.SendWhisper("D");
                    Room.SendMessage(new ChatComposer(User.VirtualId, "*Hat grad versucht sich selber zu umarmen*", 0, 34));
                    return;
                }
                else if (TargetID.TeleportEnabled)
                {
                    Session.LogsNotif("Deaktiviere den Teleport-Modus.", "command_notification");
                    return;
                }
                else
                {
                    if (User != null)
                    {
                        if ((Math.Abs((int)(TargetID.X - User.X)) < 2) && (Math.Abs((int)(TargetID.Y - User.Y)) < 2))
                        {
                            Room.SendMessage(new ChatComposer(User.VirtualId, "* " + Session.GetHabbo().Username + ", " + Params[1] + " sarildi!*", 0, 16));
                            Room.SendMessage(new ChatComposer(TargetID.VirtualId, "* " + Params[1] + " geri sarildi " + Session.GetHabbo().Username + " adli kisiye!*", 0, 16));
                            TargetID.ApplyEffect(168);
                            User.ApplyEffect(168);
                            System.Threading.Thread.Sleep(2000);
                            TargetID.ApplyEffect(0);
                            User.ApplyEffect(0);
                        }
                        else
                        {
                            Session.SendWhisper("Der Habbo steht zu weit weg.");
                            return;
                        }
                    }
                }
            }
        }

    }
}