﻿using Bios.Communication.Packets.Outgoing.Rooms.Engine;
using System.Text;
using Bios.Communication.Packets.Outgoing.Notifications;
using Bios.Communication.Interfaces;
using Bios.Communication.Packets.Outgoing.Inventory.Purse;
using Bios.Communication.Packets.Outgoing.Rooms.Chat;
using Bios.Communication.Packets.Outgoing.Rooms.Notifications;
using System;
using System.Threading;
using Bios.HabboHotel.Rooms.Games.Teams;

namespace Bios.HabboHotel.Rooms.Chat.Commands.User.Fun 
{
    class WaffenCommand : IChatCommand
    {
        public string PermissionRequired => "command_pet";
        public string Parameters => "";
        public string Description => "Verschiedene Waffen anlegen.";

        public void Execute(GameClients.GameClient Session, Room Room, string[] Params)
        {

            RoomUser ThisUser = Session.GetHabbo().CurrentRoom.GetRoomUserManager().GetRoomUserByHabbo(Session.GetHabbo().Username);
            if (Params.Length == 1)
            {
                StringBuilder List = new StringBuilder("");
                Session.SendMessage(new MOTDNotificationComposer("Liste aller Waffen\n" +
                "\n" +
                ":waffen Lichtschwert Grün [510]\n" +
                ":waffen Lichtschwert Rot [511]\n" +
                ":waffen Lichschwert Gelb [512]\n" +
                ":waffen Lichschwert Blau [513]\n" +
                ":waffen Lichschwert Lila [515]\n" +
                ":waffen Leuchtendes Lichtwert Grün [524]\n" +
                ":waffen Leuchtendes Lichtwert Rot [525]\n" +
                ":waffen AK 999 [540]"));
                return;
            }

            int EffectId = 0;
            if (!int.TryParse(Params[1], out EffectId))
                return;
            if (EffectId == 0)
            {
                Session.SendWhisper("Diese Waffe haben wir derzeit noch nicht auf Lager.");
                return;
            }

            //Change the users Pet Id.
            Session.GetHabbo().Effects().ApplyEffect(EffectId);

            //Naricht wird abgeschickt, nachdem Befehl ausgeführt wird.
            if (EffectId > 0)
                Session.SendWhisper("Schreibe (:waffe ablegen), um deine Waffe abzulegen.");
        }

        private int GetEffectbyEffect(string EffectId)
        {
            switch (EffectId)
            {
                default:
                    return 0;
                case "510":
                    return 510;
                case "511":
                    return 511;
                case "512":
                    return 512;
                case "513":
                    return 513;
                case "515":
                    return 515;
                case "524":
                    return 524;
                case "525":
                    return 525;
                case "540":
                    return 540;
            }
        }
    }
}