﻿using System;
using Bios.HabboHotel.GameClients;
using Bios.Communication.Packets.Outgoing.Rooms.Chat;


namespace Bios.HabboHotel.Rooms.Chat.Commands.User.Fun
{
    class WillkommenCommand : IChatCommand
    {
        public string PermissionRequired => "command_kiss";
        public string Parameters => "<Habbo>";
        public string Description => "Einen Habbo begrüßen.";

        public void Execute(GameClient Session, Room Room, string[] Params)
        {
            if (Params.Length == 1)
            {
                Session.SendWhisper("Lutfen bir Habbo adi gir! (:wil <Habbo>).");
                return;
            }
            GameClient Target = BiosEmuThiago.GetGame().GetClientManager().GetClientByUsername(Params[1]);
            if (Target == null)
            {
                Session.SendWhisper("Bu Habbo bulunamadi.");
                return;
            }
            else
            {
                RoomUser TargetID = Room.GetRoomUserManager().GetRoomUserByHabbo(Target.GetHabbo().Id);
                RoomUser User = Room.GetRoomUserManager().GetRoomUserByHabbo(Session.GetHabbo().Id);
                if (TargetID == null)
                {
                    Session.LogsNotif("Bu Habbo bulunamadi.", "command_notification");
                    return;
                }
                else if (Target.GetHabbo().Username == Session.GetHabbo().Username)
                {
                    Session.SendWhisper("Kendine bunu yapamazsın!");
                    Room.SendMessage(new ChatComposer(User.VirtualId, "*Kendine hosgeldin dedi*", 0, 34));
                    return;
                }
                else if (TargetID.TeleportEnabled)
                {
                    Session.LogsNotif("Bu kullanicida teleport-mod var.", "command_notification");
                    return;
                }
                else
                {
                    if (User != null)
                    {
                            Room.SendMessage(new ChatComposer(User.VirtualId, "Kabbo Hotele hosgeldin, " + Params[1] + "! Hotelde sana eglenceler diliyorum.", 0, 2));
                       
                      
                    }
                }
            }
        }

    }
}