﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Globalization;
using System.IO;
using System.Text;
using System.Windows.Forms;
using System.Reflection;
using MySql.Data.MySqlClient;
using Bios.Core;
using Bios.HabboHotel;
using Bios.HabboHotel.GameClients;
using Bios.HabboHotel.Users;
using Bios.HabboHotel.Users.UserData;
using Bios.Communication.RCON;
using Bios.Communication.ConnectionManager;
using Bios.Utilities;
using log4net;
using System.Collections.Concurrent;
using Bios.Communication.Packets.Outgoing.Moderation;
using Bios.Communication.Encryption.Keys;
using Bios.Communication.Encryption;
using Bios.Database.Interfaces;
using Bios.HabboHotel.Cache.Type;
using Bios.Database;

using System.Linq;

using System.Data;


namespace Bios.HabboHotel.Users
{
    public class HabboStats
    {
        public int HabboId { get; set; }
        public int RoomVisits { get; set; }
        public double OnlineTime { get; set; }
        public int Respect { get; set; }
        public int RespectGiven { get; set; }
        public int GiftsGiven { get; set; }
        public int GiftsReceived { get; set; }
        public int DailyRespectPoints { get; set; }
        public int DailyPetRespectPoints { get; set; }
        public int AchievementPoints { get; set; }
        public int QuestID { get; set; }
        public int QuestProgress { get; set; }
        public int FavouriteGroupId { get; set; }
        public string RespectsTimestamp { get; set; }
        public int ForumPosts { get; set; }
        public int WelcomeLevel { get; set; }
        public bool PurchaseUsersConcurrent { get; set; }

        public HabboStats(int habboId, int roomVisits, double onlineTime, int Respect, int respectGiven, int giftsGiven, int giftsReceived, int dailyRespectPoints, int dailyPetRespectPoints, int achievementPoints, int questID, int questProgress, int groupID, string RespectsTimestamp, int ForumPosts, bool PurchaseUsersConcurrent)
        {


            HabboId = habboId;
            RoomVisits = roomVisits;
            OnlineTime = onlineTime;
            this.Respect = Respect;
            RespectGiven = respectGiven;
            GiftsGiven = giftsGiven;
            GiftsReceived = giftsReceived;
            DailyRespectPoints = dailyRespectPoints;
            DailyPetRespectPoints = dailyPetRespectPoints;
            AchievementPoints = achievementPoints;
            QuestID = questID;
            QuestProgress = questProgress;
            FavouriteGroupId = groupID;
            this.RespectsTimestamp = RespectsTimestamp;
            this.ForumPosts = ForumPosts;
            WelcomeLevel = 0;
            this.PurchaseUsersConcurrent = PurchaseUsersConcurrent;

        }
                    public List<int> openedGifts { get; private set; }

        public void addOpenedGift(int eventDate)
        {
            if (this.openedGifts.Contains(eventDate))
            {
                return;
            }

            this.openedGifts.Add(eventDate);
            string[] giftData = this.openedGifts.Select(giftDay => giftDay.ToString()).ToArray();

            using (IQueryAdapter dbClient = BiosEmuThiago.GetDatabaseManager().GetQueryReactor())
            {
                dbClient.SetQuery("UPDATE `user_stats` SET `calendar_gifts` = @giftData WHERE `id` = @habboId LIMIT 1");
                dbClient.AddParameter("giftData", string.Join(",", giftData));
                dbClient.AddParameter("habboId", HabboId);
                dbClient.RunQuery();
            }

        }
    }


    }

