﻿using Bios.Database.Interfaces;
using Bios.Communication.Packets.Outgoing.Rooms.Notifications;
using Bios.Core;
using System;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Administrator
{
    class BubbleBotCommand : IChatCommand
    {
        public string PermissionRequired => "command_bubble";
        public string Parameters => "<Bot> <Bubble-ID>";
        public string Description => "Die Sprechblase eines Bots verändern.";

        public void Execute(GameClients.GameClient Session, Rooms.Room Room, string[] Params)
        {
            RoomUser User = Room.GetRoomUserManager().GetRoomUserByHabbo(Session.GetHabbo().Id);
            if (User == null)
                return;

            if (Params.Length == 1)
            {
                Session.SendWhisper("Bitte gib einen Botnamen sowie eine Bubble-ID ein (:botbubble <Bot> <Bubble-ID>).");
                return;
            }

            if (Params.Length == 2)
            {
                Session.SendWhisper("Ungültige Eingabe.");
                return;
            }
            string BotName = CommandManager.MergeParams(Params, 1);
            string Bubble = CommandManager.MergeParams(Params, 2);
            using (IQueryAdapter dbClient = BiosEmuThiago.GetDatabaseManager().GetQueryReactor())
            {
                dbClient.runFastQuery("UPDATE `bots` SET `chat_bubble` =  '" + Params[2] + "' WHERE `name` =  '" + Params[1] + "' AND  `room_id` =  '" + Session.GetHabbo().CurrentRoomId + "'");
                Session.LogsNotif("Folgende Bubble-ID wurde getätigt: " + Params[1] + " [ACHTUNG: RELOADE JETZT DEN RAUM]!", "command_notification");
            }
        }
    }
}