﻿using Bios.HabboHotel.GameClients;
using Bios.Communication.Packets.Outgoing.Rooms.Notifications;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Events
{
    class CatalogUpdateAlert : IChatCommand
    {
        public string PermissionRequired => "command_addpredesigned";
        public string Parameters => "<Naricht>";
        public string Description => "Alert zu einem Katalog Update.";

        public void Execute(GameClient Session, Room Room, string[] Params)
        {
            string Message = CommandManager.MergeParams(Params, 1);

            BiosEmuThiago.GetGame().GetClientManager().SendMessage(new RoomNotificationComposer("Katalog wurde aktualisiert!",
              "Der <font color=\"#2E9AFE\"><b>Habbo</b></font> Katalog wurde vor kurzem aktualisiert! Öffne den Katalog und schau dir unsere <b>neuen Möbel</b> an.<br>", "cata", "Katalog öffnen", "event:catalog/open/" + Message));

            Session.SendWhisper("Alert wurde abgeschickt.");
        }
    }
}

