﻿using Bios.Communication.Packets.Outgoing.Rooms.Notifications;
using Bios.HabboHotel.Rooms;
using Bios.HabboHotel.GameClients;
using Bios.Communication.Packets.Outgoing.Rooms.Engine;
using System.Linq;
using Bios.Communication.Packets.Outgoing.Inventory.Purse;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Events
{
    internal class EventAlertCommand : IChatCommand
    {
        public string PermissionRequired
        {
            get
            {
                return "command_event_alert";
            }
        }
        public string Parameters
        {
            get
            {
                return "<Beschreibung>";
            }
        }
        public string Description
        {
            get
            {
                return "Event-Benarichtigung abschicken.";
            }
        }
        public void Execute(GameClient Session, Room Room, string[] Params)
        {
            if (Session != null)
            {
                if (Room != null)
                {
                    if (Params.Length == 1)
                    {
                        Session.SendWhisper("EHA icin lutfen bir mesaj girin! (:eha <mesaj>).");
                        return;
                    }
                    foreach (GameClient client in BiosEmuThiago.GetGame().GetClientManager().GetClients.ToList())
                        if (client.GetHabbo().AllowEvents == true)
                        {
                            string Message = CommandManager.MergeParams(Params, 1);

                            client.SendMessage(new RoomNotificationComposer("Hotel Eventi!",
                                 "Bir etkinlik bir personel tarafından başlatıldı!<br><br>Harika ödüller almak için etkinlikleri oynayin.<br><br>Mesaj:<b>  " + Message +
                                 "</b><br>Tarafindan:<b>  " + Session.GetHabbo().Username +
                                 "</b> <br><br>Yönetim size çok eğlenmenizi diler. <br><br>Etkinlik bildirimlerini görmek istemiyorsaniz <b>:disableevents</b> yazarak devre disi birak!",
                                 "events", "EVENTE GIT!", "event:navigator/goto/" + Session.GetHabbo().CurrentRoomId));
                        }
                        else
                            client.SendWhisper("Du kannst Event-Benarichtigungen wieder aktivieren, indem du (:alertas) schreibst.", 1);

                }
            }
        }
    }
}