﻿using System;
using System.Linq;
using System.Collections.Generic;
using Bios.Communication.Packets.Outgoing.Rooms.Avatar;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Moderator.Fun
{
    class MassDanceCommand : IChatCommand
    {
        public string PermissionRequired => "command_massdance"; 
        public string Parameters => "<Tanz-ID>"; 
        public string Description => "Jeder im Raum wird tanzen.";

        public void Execute(GameClients.GameClient Session, Rooms.Room Room, string[] Params)
        {
            
            if (Params.Length == 1)
            {
                Session.SendWhisper("Bitte gib eine Tanz-ID ein (:massdance <Tanz-ID>(1-4)).");
                return;
            }

            int DanceId = Convert.ToInt32(Params[1]);
            if (DanceId < 0 || DanceId > 4)
            {
                Session.SendWhisper("Tanz-ID ziwschen 1-4.");
                return;
            }

            List<RoomUser> Users = Room.GetRoomUserManager().GetRoomUsers();
            if (Users.Count > 0)
            {
                foreach (RoomUser U in Users.ToList())
                {
                    if (U == null)
                        continue;

                    if (U.CarryItemID > 0)
                        U.CarryItemID = 0;

                    U.DanceId = DanceId;
                    Room.SendMessage(new DanceComposer(U,DanceId));
                }
            }
        }
    }
}
