﻿using Bios.Communication.Packets.Outgoing.Rooms.Notifications;
using Bios.Core;
using Bios.HabboHotel.GameClients;
using System;
using Bios.Communication.Packets.Outgoing.Moderation;
using Bios.Communication.Packets.Outgoing.Rooms.Notifications;
using Bios.Communication.Packets.Outgoing.Rooms.Chat;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Moderator
{
    class GiveBadgeCommand : IChatCommand
    {
        public string PermissionRequired => "command_give_badge";
        public string Parameters => "<Habbo> <Badge-ID>";
        public string Description => "Einem Habbo ein Badge vergeben.";

        public void Execute(GameClient Session, Room Room, string[] Params)
        {
           
            if (Params.Length != 3)
            {
                Session.SendWhisper("Lütfen bir Habbo Adı ve Rozet kodu girin. (:givebadge <Habbo> <Badge-ID>).");
                return;
            }

            GameClient TargetClient = BiosEmuThiago.GetGame().GetClientManager().GetClientByUsername(Params[1]);
            if (TargetClient != null)
            {
                if (!TargetClient.GetHabbo().GetBadgeComponent().HasBadge(Params[2]))
                {
                    TargetClient.GetHabbo().GetBadgeComponent().GiveBadge(Params[2], true, TargetClient);
                    if (TargetClient.GetHabbo().Id != Session.GetHabbo().Id)
                        TargetClient.SendMessage(RoomNotificationComposer.SendBubble("badge/" + Params[2], "Az önce bir personelden rozet aldin!.", "/inventory/open/badge"));
                    
                
                else
                    Session.SendMessage(RoomNotificationComposer.SendBubble("badge/" + Params[2], "Az once bir oyuncuya rozet yolladin: " + Params[2], " /inventory/open/badge"));
                    BiosEmuThiago.GetGame().GetClientManager().StaffAlert(new WhisperComposer(1, "@red@Phoenix: " + Session.GetHabbo().Username + " adindaki staff, " + Params[1] + " bir rozet verdi. (" + Params[2] + ")", 0, 1));
                }
                else
                    Session.SendWhisper("Bu Habbo zaten bu rozete sahip.(" + Params[2] + ") !");
                return;
            }
            else
            {
                Session.SendWhisper("Bu Habbo bulunamadi.");
                return;
            }
        }
    }
}
