﻿using Bios.Communication.Packets.Outgoing.Rooms.Notifications;
using Bios.HabboHotel.GameClients;
using Bios.Communication.Packets.Outgoing.Inventory.Purse;
using System.Text;
using Bios.Communication.Packets.Outgoing.Notifications;
using Bios.Communication.Packets.Outgoing.Rooms.Chat;
using Bios.Core;
using System;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Moderator
{
    class GiveCommand : IChatCommand
    {
        public string PermissionRequired => "command_give";
        public string Parameters => "<Habbo> <Währung> <Menge>";
        public string Description => "Taler, Duckets, Diamanten oder ? vergeben.";

        public void Execute(GameClient Session, Room Room, string[] Params)
        {

            if (Params.Length == 1)
            {
                StringBuilder List = new StringBuilder();
                List.Append("Hilfe\n········································································\n");
                List.Append(":give <credits> <value>\n········································································\n");
                List.Append(":give <Diamanten> <value>\n········································································\n");
                List.Append(":give <Duckets> <value>\n········································································\n");
                List.Append(":give <?> <value>\n········································································\n");
                Session.SendMessage(new MOTDNotificationComposer(List.ToString()));
                return;
            }

            GameClient Target = BiosEmuThiago.GetGame().GetClientManager().GetClientByUsername(Params[1]);
            if (Target == null)
            {
                Session.SendWhisper("Bitte gib einen Habbonamen ein (:give <Habbo> <Währung> <Menge>).");
                return;
            }

            string UpdateVal = Params[2];
            switch (UpdateVal.ToLower())
            {
                case "credits":
                    {
                        if (!Session.GetHabbo().GetPermissions().HasCommand("command_give_coins"))
                        {
                            Session.SendWhisper("Bunu yapma izniniz yok.");
                            break;
                        }
                        else
                        {
                            int Amount;
                            if (int.TryParse(Params[3], out Amount))
                            {
                                Target.GetHabbo().Credits = Target.GetHabbo().Credits += Amount;
                                Target.SendMessage(new CreditBalanceComposer(Target.GetHabbo().Credits));
                                Session.SendMessage(new RoomNotificationComposer("tickets", "message", "Sen " + Amount + " kredi verdin " + Target.GetHabbo().Username + " adindaki oyuncuya."));
                                Target.SendMessage(new RoomNotificationComposer("cred", "message", "Sen " + Amount + " kredi aldin " + Session.GetHabbo().Username + " adindaki personelden."));
                                BiosEmuThiago.GetGame().GetClientManager().StaffAlert(RoomNotificationComposer.SendBubble("advice", "" + Session.GetHabbo().Username + " adli personel " + Amount + " kredi " + Target.GetHabbo().Username + " adli oyuncuya verdi.", "event:navigator/goto/" + Session.GetHabbo().CurrentRoomId));
                                BiosEmuThiago.GetGame().GetClientManager().StaffAlert(new WhisperComposer(1, "" + Session.GetHabbo().Username + " adli personel " + Amount + " Kredi " + Target.GetHabbo().Username + " adli oyuncuya verdi.", 0, 1));
                                break;
                            }




                            else

                            {
                                Session.SendWhisper("Geçersiz giriş!");
                                break;
                            }
                        }
                    }

                case "pixels":
                case "duckets":
                    if (!Session.GetHabbo().GetPermissions().HasCommand("command_give_pixels"))
                    {
                        Session.SendWhisper("Bunu yapma izniniz yok.");
                        break;
                    }
                    else
                    {
                        int Amount;
                        if (int.TryParse(Params[3], out Amount))
                        {
                            Target.GetHabbo().Duckets += Amount;
                            Target.SendMessage(new HabboActivityPointNotificationComposer(Target.GetHabbo().Duckets, Amount));

                            Session.SendMessage(new RoomNotificationComposer("tickets", "message", "Sen " + Amount + " ördek verdin " + Target.GetHabbo().Username + " adindaki oyuncuya."));
                            Target.SendMessage(new RoomNotificationComposer("duckets", "message", "Sen " + Amount + " ördek aldin " + Session.GetHabbo().Username + " adindaki personelden."));
                            BiosEmuThiago.GetGame().GetClientManager().StaffAlert(RoomNotificationComposer.SendBubble("advice", "" + Session.GetHabbo().Username + " adli personel " + Amount + " ordek " + Target.GetHabbo().Username + " adli oyuncuya verdi.", "event:navigator/goto/" + Session.GetHabbo().CurrentRoomId));
                            BiosEmuThiago.GetGame().GetClientManager().StaffAlert(RoomNotificationComposer.SendBubble("advice", "" + Session.GetHabbo().Username + " adli personel " + Amount + " ordek " + Target.GetHabbo().Username + " adli oyuncuya verdi.", "event:navigator/goto/" + Session.GetHabbo().CurrentRoomId));
                            break;
                        }
                        else

                        {
                            Session.SendWhisper("Geçersiz giriş!");
                            break;
                        }
                    }

                case "diamonds":
                case "diamanten":
                    if (!Session.GetHabbo().GetPermissions().HasCommand("command_give_diamonds"))
                    {
                        Session.SendWhisper("Bunu yapma izniniz yok.");
                        break;
                    }
                    else
                    {
                        int Amount;
                        if (int.TryParse(Params[3], out Amount))

                        {
                            Target.GetHabbo().Diamonds += Amount;
                            Target.SendMessage(new HabboActivityPointNotificationComposer(Target.GetHabbo().Diamonds, 0, 5));
                            Session.SendMessage(new RoomNotificationComposer("tickets", "message", "Sen " + Amount + " elmas verdin " + Target.GetHabbo().Username + " adindaki oyuncuya."));
                            Target.SendMessage(new RoomNotificationComposer("diamonds", "message", "Sen " + Amount + " elmas aldin " + Session.GetHabbo().Username + " adindaki personelden."));
                            BiosEmuThiago.GetGame().GetClientManager().StaffAlert(RoomNotificationComposer.SendBubble("advice", "" + Session.GetHabbo().Username + " adli personel " + Amount + " elmas " + Target.GetHabbo().Username + " adli oyuncuya verdi.", "event:navigator/goto/" + Session.GetHabbo().CurrentRoomId));
                            BiosEmuThiago.GetGame().GetClientManager().StaffAlert(RoomNotificationComposer.SendBubble("advice", "" + Session.GetHabbo().Username + " adli personel " + Amount + " elmas " + Target.GetHabbo().Username + " adli oyuncuya verdi.", "event:navigator/goto/" + Session.GetHabbo().CurrentRoomId));


                            break;

                        }
                        else
                        {
                            Session.SendWhisper("Geçersiz giriş!");
                            break;
                        }

                    }



                case "gotw":
                case "gotws":
                case "gotwpoints":
                case "fame":
                case "fama":
                case "famepoints":
                    if (!Session.GetHabbo().GetPermissions().HasCommand("command_give_gotw"))
                    {
                        Session.SendWhisper("Bunu yapma izniniz yok.");
                        break;
                    }
                    else
                    {
                        int Amount;
                        if (int.TryParse(Params[3], out Amount))
                        {
                            if (Amount > 500)
                            {
                                Session.SendWhisper("500'den daha fazla veremezsin.");
                                return;
                            }

                            Target.GetHabbo().GOTWPoints = Target.GetHabbo().GOTWPoints + Amount;
                            Target.GetHabbo().UserPoints = Target.GetHabbo().UserPoints + 1;
                            Target.SendMessage(new HabboActivityPointNotificationComposer(Target.GetHabbo().GOTWPoints, Amount, 103));

                            if (Target.GetHabbo().Id != Session.GetHabbo().Id)
                                Target.SendMessage(RoomNotificationComposer.SendBubble("moedas", "" + Session.GetHabbo().Username + " aldi " + Amount + " " + Core.ExtraSettings.PTOS_COINS + ".\nMevcut ödülleri görmek için tıklayın.", "catalog/open/gotws"));
                            Session.SendMessage(RoomNotificationComposer.SendBubble("furni_placement_error", "Az önce gönderdin. " + Amount + " " + Core.ExtraSettings.PTOS_COINS + " " + Target.GetHabbo().Username + "\nBu komutlari akillica kullan, personellerin seni gordugunu unutma!", "catalog/open/gotws"));
                            BiosEmuThiago.GetGame().GetAchievementManager().ProgressAchievement(Target, "ACH_EventsWon", 1);
                            break;
                        }
                        else
                        {
                            Session.SendWhisper("Sadece 1 ile 50 arasında sayısal parametreler girebilirsiniz.");
                            break;
                        }
                    }
            }
        }
    }
}