﻿using Bios.Communication.Packets.Outgoing.Inventory.Purse;
using Bios.Core;
using Bios.HabboHotel.GameClients;
using System;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Moderator
{
    class GiveRoomCommand : IChatCommand
    {
        public string PermissionRequired => "command_give_room";
        public string Parameters => "<Menge>";
        public string Description => "Alle im Raum erhalten Belohnungen.";

        public void Execute(GameClient Session, Room Room, string[] Params)
        {
            if (Params.Length == 1)
            {
                Session.SendWhisper("Bitte gib einen Betrag ein (:giveroom <Menge>).");
                return;
            }
			if (int.TryParse(Params[1], out int Amount))

				foreach (RoomUser RoomUser in Room.GetRoomUserManager().GetRoomUsers())
				{
					if (RoomUser == null || RoomUser.GetClient() == null || Session.GetHabbo().Id == RoomUser.UserId)
						continue;
					RoomUser.GetClient().GetHabbo().Credits += Amount;
					RoomUser.GetClient().SendMessage(new CreditBalanceComposer(RoomUser.GetClient().GetHabbo().Credits));
				}
		}
}
}
  