﻿using Bios.Communication.Packets.Outgoing.Moderation;
using Bios.Communication.Packets.Outgoing.Rooms.Chat;
using Bios.Core;
using Bios.Communication.Packets.Outgoing.Rooms.Notifications;
using System;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Moderator
{
    class HaCommand : IChatCommand
    {
        public string PermissionRequired => "command_hotel_alert";
        public string Parameters => "<Naricht>";
        public string Description => "Eine Hotelnaricht abschicken.";

        public void Execute(GameClients.GameClient Session, Rooms.Room Room, string[] Params)
        {
            if (Params.Length == 1)
            {
                Session.SendWhisper("Bitte gib eine Naricht ein (:info <Naricht>).");
                return;
            }


            else
                BiosEmuThiago.GetGame().GetClientManager().StaffAlert(RoomNotificationComposer.SendBubble("advice", "" + Session.GetHabbo().Username + " hat eine Info-Alert abgeschickt.", "event:navigator/goto/" + Session.GetHabbo().CurrentRoomId));

            int OnlineUsers = BiosEmuThiago.GetGame().GetClientManager().Count;
            int RoomCount = BiosEmuThiago.GetGame().GetRoomManager().Count;
            string Message = CommandManager.MergeParams(Params, 1);
            BiosEmuThiago.GetGame().GetClientManager().SendMessage(new ChatComposer(1, "@green@INFO: " + Message + "", 0, 1));
            return;
        }
    }
}
