﻿using Bios.Communication.Packets.Outgoing.Rooms.Poll;
using Bios.Core;
using Bios.HabboHotel.GameClients;
using Bios.HabboHotel.Items;
using System;
using System.Collections.Generic;
using System.Linq;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Moderator
{

    internal class IdolQuizCommand : IChatCommand
    {
        public string PermissionRequired => "command_alert_user";
        public string Parameters => "<Naricht>";
        public string Description => "Alert zu einem Katalog Update.";

        public void Execute(GameClient Session, Room Room, string[] Params)
        {
            if (Params.Length == 1)
            {
                Session.SendWhisper("Bitte Frage eingeben.");
            }
            else
            {

                string question = "< Gefällt mir [ " + Params[1] + " ] Gefällt mir nicht >";
                if (Session.GetHabbo().Rank > 0)
                {
                    Item[] ReloadItems = Room.GetRoomItemHandler().GetFloor.ToArray();
                    foreach (Item Chair in ReloadItems.ToList())
                    {
                        if (Chair.GetBaseItem().InteractionType == InteractionType.idol_chair)
                        {
                            Chair.ExtraData = "0";
                            Chair.UpdateState();
                        }
                        if (Chair.GetBaseItem().InteractionType == InteractionType.idol_counter)
                        {
                            Chair.ExtraData = "0";
                            Chair.UpdateState();
                        }

                        Room.EndQuestion();
                    }
                }
                else
                {

                    Item[] Items = Room.GetRoomItemHandler().GetFloor.ToArray();
                    foreach (Item Chair in Items.ToList())
                    {
                        if (Chair.GetBaseItem().InteractionType == InteractionType.idol_chair)
                        {

                            bool HasUsers = false;

                            if (Room.GetGameMap().SquareHasUsers(Chair.GetX, Chair.GetY))
                                HasUsers = true;

                            if (!HasUsers)
                            {
                                Session.SendWhisper("Es gibt keinen Richter.");
                                return;
                            }
                            BiosEmuThiago.GetGame().GetClientManager().QuizzAlert(new QuickPollMessageComposer(question), Chair, Room);
                            Room.SetPoolQuestion(question);
                            Room.ClearPoolAnswers();
                            Console.WriteLine(question);
                        }
                    }
                }
            }
        }
    }
}