﻿using Bios.Core;
using Bios.HabboHotel.GameClients;
using System;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Moderator
{
    class KickCommand : IChatCommand
    {
        public string PermissionRequired => "command_kick";
        public string Parameters => "<Habbo> <Grund>";
        public string Description => "Einen Habbo aus dem Raum kicken.";

        public void Execute(GameClient Session, Room Room, string[] Params)
        {

            if (Params.Length == 1)
            {
                Session.SendWhisper("Bitte gib einen Habbonamen sowie ein Grund ein (:kick <Habbo> <Grund>).");
                return;
            }

            GameClient TargetClient = BiosEmuThiago.GetGame().GetClientManager().GetClientByUsername(Params[1]);
            if (TargetClient == null)
            {
                Session.SendWhisper("Dieser Habbo konnte nicht gefunden werden.");
                return;
            }

            if (TargetClient.GetHabbo() == null)
            {
                Session.SendWhisper("Dieser Habbo konnte nicht gefunden werden.");
                return;
            }

            if (TargetClient.GetHabbo().Username == Session.GetHabbo().Username)
            {
                Session.SendWhisper("Sehr witzig.");
                return;
            }

            if (!TargetClient.GetHabbo().InRoom)
            {
                Session.SendWhisper("Dieser Habbo konnte nicht gefunden werden.");
                return;
            }

            Room TargetRoom;
            if (!BiosEmuThiago.GetGame().GetRoomManager().TryGetRoom(TargetClient.GetHabbo().CurrentRoomId, out TargetRoom))
                return;

            if (Params.Length > 2)
                TargetClient.SendNotification("Ein Moderator hat dich aus folgendem Grund gekickt: " + CommandManager.MergeParams(Params, 2));
            else
                TargetClient.SendNotification("Ein Moderator hat dich aus dem Raum gekickt.");

            TargetRoom.GetRoomUserManager().RemoveUserFromRoom(TargetClient, true, false);
        }
    }
}
