﻿using System.Linq;
using Bios.HabboHotel.GameClients;
using Bios.Communication.Packets.Outgoing.Rooms.Notifications;
using Bios.Core;
using System;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Moderator
{
    class MassBadgeCommand : IChatCommand
    {
        public string PermissionRequired => "command_mass_badge";
        public string Parameters => "<Badge-ID>";
        public string Description => "Jeden im Hotel ein Badge vergeben.";

        public void Execute(GameClient Session, Room Room, string[] Params)
        {
            if (Params.Length == 1)
            {
                Session.SendWhisper("Bitte gib eine Badge ID ein (:massbadge <Badge-ID>).");
                return;
            }

            foreach (GameClient Client in BiosEmuThiago.GetGame().GetClientManager().GetClients.ToList())
            {
                if (Client == null || Client.GetHabbo() == null || Client.GetHabbo().Username == Session.GetHabbo().Username)
                    return;

                if (!Client.GetHabbo().GetBadgeComponent().HasBadge(Params[1]))
                {
                    Client.GetHabbo().GetBadgeComponent().GiveBadge(Params[1], true, Client);
                    Client.SendMessage(RoomNotificationComposer.SendBubble("badge/" + Params[1], "Du hast soeben ein Badge bekommen.", "/inventory/open/badge"));
                }
                else
                    Client.SendWhisper(Session.GetHabbo().Username + " Du besitzt bereits dieses Badge!");
            }

            Session.SendWhisper("Allen im Hotel wurde: " + Params[1] + " Badge erfolgreich vergeben!");
        }
    }
}
