﻿using Bios.Core;
using Bios.Database.Interfaces;
using Bios.HabboHotel.Users;
using System;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Moderator
{
    class MuteCommand : IChatCommand
    {
        public string PermissionRequired => "command_mute";
        public string Parameters => "<Habbo> <Dauer>";
        public string Description => "Einen Habbo stummschalten.";

        public void Execute(GameClients.GameClient Session, Room Room, string[] Params)
        {
            if (Params.Length == 1)
            {
                Session.SendWhisper("Bitte gib einen Habbonamen und eine Dauer ein (:mute <Habbo> <Dauer>).");
                return;
            }

            Habbo Habbo = BiosEmuThiago.GetHabboByUsername(Params[1]);
            if (Habbo == null)
            {
                Session.SendWhisper("Der Habbo konte nicht gefunden werden.");
                return;
            }

            if (Habbo.GetPermissions().HasRight("mod_tool") && !Session.GetHabbo().GetPermissions().HasRight("mod_mute_any"))
            {
                Session.SendWhisper("Du kannst diesen Habbo nicht stummschalten.");
                return;
            }

			if (double.TryParse(Params[2], out double Time))
			{
				if (Time > 600 && !Session.GetHabbo().GetPermissions().HasRight("mod_mute_limit_override"))
					Time = 600;

				using (IQueryAdapter dbClient = BiosEmuThiago.GetDatabaseManager().GetQueryReactor())
				{
					dbClient.runFastQuery("UPDATE `users` SET `time_muted` = '" + Time + "' WHERE `id` = '" + Habbo.Id + "' LIMIT 1");
				}

				if (Habbo.GetClient() != null)
				{
					Habbo.TimeMuted = Time;
					Habbo.GetClient().SendNotification("Du wurdest von einem Moderator für" + Time + " Sekunden stummgeschaltet!");
				}

				Session.SendWhisper("" + Habbo.Username + " wurde für " + Time + " Sekunden stummgeschaltet.");
			}
			else
				Session.SendWhisper("Ungültige Eingabe.");
		}
    }
}