﻿using System;
using System.Linq;
using System.Text;
using System.Collections.Generic;
using Bios.Database.Interfaces;

using Bios.HabboHotel.GameClients;
using Bios.Communication.Packets.Outgoing.Rooms.Session;
using Bios.Communication.Packets.Outgoing.Rooms.Notifications;
using Bios.Communication.Packets.Outgoing.Rooms.Engine;
using Bios.Core;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Moderator
{
    class PrisonCommand : IChatCommand
    {
        public string PermissionRequired
        {
            get { return "command_alert_user"; }
        }

        public string Parameters
        {
            get { return "%username%"; }
        }

        public string Description
        {
            get { return "Hapishaneye at!"; }
        }

        public void Execute(GameClients.GameClient Session, Rooms.Room Room, string[] Params)
        {
            GameClient TargetClient = BiosEmuThiago.GetGame().GetClientManager().GetClientByUsername(Params[1]);

            if (Params.Length == 1)
            {
                Session.SendWhisper("Tutuklamak istediğiniz kullanıcıyı seçin!");
                return;
            }

            if (TargetClient.GetHabbo().Id == Session.GetHabbo().Id)
            {
                Session.SendWhisper("Kendini tutuklayamazsın!");
            }

            if (TargetClient.GetHabbo().Username == null)
            {
                Session.SendWhisper("Kullanıcı mevcut değil!");
                return;
            }

            if (TargetClient.GetHabbo().GetPermissions().HasRight("mod_soft_ban") && !Session.GetHabbo().GetPermissions().HasRight("mod_ban_any"))
            {
                Session.SendWhisper("Bu kullanıcıyı tutuklayamazsın!");
                return;
            }

            if (Session.GetHabbo().Rank < TargetClient.GetHabbo().Rank)
            {
                Session.SendWhisper("Bu kullanıcıyı tutuklayamazsın! (Bu kullanıcının ranki senden yüksek olabilir!");
                return;
            }

            Random rnd = new Random();
            int prisonerClothes = rnd.Next(1, 2);

            if (TargetClient.GetHabbo().Id != Session.GetHabbo().Id && Session.GetHabbo().isOfficer)
            {

                using (IQueryAdapter dbClient = BiosEmuThiago.GetDatabaseManager().GetQueryReactor())
                {
                    dbClient.SetQuery("SELECT ip_reg FROM users WHERE id=' " + TargetClient.GetHabbo().Id + "' LIMIT 1");
                    dbClient.AddParameter("selectt", TargetClient.GetHabbo().Id);
                    string ipreg = dbClient.ToString();

                    dbClient.SetQuery("SELECT ip_reg FROM users where ip_reg='" + ipreg + "' LIMTI 1");
                    dbClient.AddParameter("select", TargetClient.GetHabbo().Id);
                    string ipMatch = dbClient.ToString();



                   

                    if (ipreg == ipMatch)
                    {
                        dbClient.RunQuery("UPDATE users SET prison ='1' WHERE ip_reg='" + ipMatch + "' LIMIT 1");
                        dbClient.AddParameter("updateP", TargetClient.GetHabbo().Id);
                    }

                    string figure = TargetClient.GetHabbo().Look;
                    BiosEmuThiago.GetGame().GetClientManager().SendMessage(new RoomNotificationComposer("fig/" + figure, 3, " " + Params[1] + " hapise atildi!", ""));

                    dbClient.RunQuery("UPDATE users SET prefix_name = 'PRISONEIRO' WHERE id = '" + TargetClient.GetHabbo().Id + "'");
                    dbClient.RunQuery("UPDATE users SET prefix_name_color = '#dc335b' WHERE id = '" + TargetClient.GetHabbo().Id + "'");

                    TargetClient.GetHabbo()._NamePrefixColor = "#dc335b";
                    TargetClient.GetHabbo()._NamePrefix = "Mahkum";
                    TargetClient.SendWhisper("Mahküm Tagi Etkinlestirildi!");

                    dbClient.RunQuery("UPDATE users SET prison = '1' WHERE ID ='" + TargetClient.GetHabbo().Id + "' LIMIT 1");
                    dbClient.RunQuery("UPDATE `users` SET `home_room` = '12' WHERE id ='" + TargetClient.GetHabbo().Id + "' LIMIT 1");
                    dbClient.RunQuery("UPDATE users SET Presidio = 'true' WHERE id = " + TargetClient.GetHabbo().Id + ";");
                    dbClient.RunQuery("UPDATE users SET motto = 'Suanda hotel hapishanesinde mahkumum!' WHERE ID = '" + TargetClient.GetHabbo().Id + "' LIMIT 1");
                    dbClient.AddParameter("updateU", TargetClient.GetHabbo().Id);
                    dbClient.AddParameter("updateU1", TargetClient.GetHabbo().Id);
                    dbClient.AddParameter("updateU2", TargetClient.GetHabbo().Id);
					dbClient.AddParameter("updateU3", TargetClient.GetHabbo().Id);

					// Comando feito por Thiago Araujo: Servidores de SAO.

					Session.SendWhisper("Oyuncuyu başarıyla tutukladın!");
                    TargetClient.SendWhisper("Tutuklandınız ve birkaç dakika içinde yeniden başlatılacaksınız.");

                    TargetClient.GetHabbo().Gender = TargetClient.GetHabbo().Gender;
                    TargetClient.GetHabbo().Look = "hr-72202184-1042-31.fa-987462888-92.sh-300-1189.lg-285-70.ch-220-70.hd-3092-1";

                    if (Session.GetHabbo().Rank > 0)
                    {

                        dbClient.SetQuery("UPDATE `users` SET `gender` = @gender, `look` = @look WHERE `id` = @id LIMIT 1");
                        dbClient.AddParameter("gender", TargetClient.GetHabbo().Gender);
                        dbClient.AddParameter("look", TargetClient.GetHabbo().Look);
                        dbClient.AddParameter("id", TargetClient.GetHabbo().Id);
                        dbClient.RunQuery();

                        RoomUser User = Room.GetRoomUserManager().GetRoomUserByHabbo(Session.GetHabbo().Id);
                        if (User != null)
                        {
                            Session.SendMessage(new UserChangeComposer(User, true));
                            Room.SendMessage(new UserChangeComposer(User, false));
                        }

                    }

                }
                Session.SendWhisper(TargetClient.GetHabbo().Username + " Artık hapiste ve hapishaneye yollandın!");

                if (!TargetClient.GetHabbo().InRoom)
                    TargetClient.SendMessage(new RoomForwardComposer(BiosEmuThiago.Prisao));
                else
                    TargetClient.GetHabbo().PrepareRoom(BiosEmuThiago.Prisao, "");
            }
            else
            {
                Session.SendWhisper("Erişiminiz yok, ya da polis modunda değilsiniz!");
            }
        }
    }
}