﻿using Bios.Core;
using System;
using System.Linq;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Moderator
{
    class RoomBadgeCommand : IChatCommand
    {
        public string PermissionRequired => "command_room_badge";
        public string Parameters => "<Badge-ID>";
        public string Description => "Ein Badge an alle die im Raum anwesend sind verteilen.";

        public void Execute(GameClients.GameClient Session, Room Room, string[] Params)
        {
            if (Params.Length == 1)
            {
                Session.SendWhisper("Lütfen bir Habbo adı ve Rozet kodu girin (:roombadge <Badge-ID>).");
                return;
            }

            foreach (RoomUser User in Room.GetRoomUserManager().GetUserList().ToList())
            {
                if (User == null || User.GetClient() == null || User.GetClient().GetHabbo() == null)
                    return;

                if (!User.GetClient().GetHabbo().GetBadgeComponent().HasBadge(Params[1]))
                {
                    User.GetClient().GetHabbo().GetBadgeComponent().GiveBadge(Params[1], true, User.GetClient());
                    User.GetClient().SendNotification("Az önce bir rozet aldin.");
                }
                else
                {
                    User.GetClient().SendWhisper(Session.GetHabbo().Username + " Zaten bu rozete sahip!");
                    return;
                }
                    
            }

            Session.SendWhisper("Rozet dağıtıldı odadaki tüm mevcut dagitilan rozetler: " + Params[2] + "!");
        }
    }
}
