﻿using System;
using System.Linq;
using System.Text;
using System.Collections.Generic;
using System.Threading;
using Bios.Communication.Packets.Incoming.Rooms.Action;
using Bios.Utilities;
using Bios.HabboHotel.Users;
using Bios.HabboHotel.GameClients;
using Bios.Communication.Packets.Outgoing.Rooms.Chat;
using Bios.HabboHotel.Rooms;

using Bios.HabboHotel.Moderation;

using Bios.Database.Interfaces;
using Bios.Communication.Packets.Outgoing.Rooms.Engine;

namespace Bios.HabboHotel.Rooms.Chat.Commands.Moderator
{
    class TazerCommand : IChatCommand
    {

        public string PermissionRequired
        {
            get { return ""; }
        }

        public string Parameters
        {
            get { return ""; }
        }

        public string Description
        {
            get { return "Zum Polizisten werden."; ; }
        }

        public void Execute(GameClients.GameClient Session, Rooms.Room Room, string[] Params)
        {
            GameClient TargetClient = BiosEmuThiago.GetGame().GetClientManager().GetClientByUsername(Params[1]);
            RoomUser ThisUser = Room.GetRoomUserManager().GetRoomUserByHabbo(Session.GetHabbo().Id);
            RoomUser TargetUser = Room.GetRoomUserManager().GetRoomUserByHabbo(TargetClient.GetHabbo().Id);

            if (Params.Length == 1)
            {
                Session.SendWhisper("Bitte gib einen Habbonamen ein (:tazer <Habbo>).");
                return;
            }

            if (TargetClient == null)
            {
                Session.SendWhisper("Der Habbo konnte nicht gefunden werden.");
                return;
            }

            if (TargetClient.GetHabbo().Username == Session.GetHabbo().Username)
            {
                Session.SendWhisper("Du kannst dich doch nicht selber tazern.");
                return;
            }

            if (ThisUser == null)
                return;

            if ((Math.Abs((int)(TargetUser.X - ThisUser.X)) < 2) && (Math.Abs((int)(TargetUser.Y - ThisUser.Y)) < 2))
            {
                if (Session.GetHabbo().Rank >= 2 && Session.GetHabbo().isOfficer == true)
                {
                    TargetUser.Frozen = true;
                    TargetUser.ApplyEffect(53);
                    Room.SendMessage(new ChatComposer(ThisUser.VirtualId, "@green@*" + Session.GetHabbo().Username + " hat mit seinem Tazer auf " + Params[1] + " geschossen*", 0, 1));
                    TargetClient.SendWhisper("Du wurdest von einem Polizisten getazert.");
                }
                else
                {
                    Session.SendWhisper("Du bist kein Polizist.");
                }
            }

            else
            {
                Session.SendWhisper("Der Habbo steht zu weit weg.");
                return;
            }
        }
    }
}