﻿using System;
using Bios.HabboHotel.GameClients;
using Bios.Communication.Packets.Outgoing.Rooms.Chat;
using Bios.Communication.Packets.Outgoing.Inventory.Purse;
using Bios.Communication.Packets.Outgoing.Rooms.Notifications;
using System.Data;
using Bios.Communication.Packets.Outgoing.Rooms.Nux;

namespace Bios.HabboHotel.Rooms.Chat.Commands.User.Fun
{
	class AusraubenCommand : IChatCommand
	{
		public string PermissionRequired
		{
			get { return "command_sit"; }
		}
		public string Parameters
		{
			get { return "<Habbo>"; }
		}
		public string Description
		{
			get { return "Einen Habbo ausrauben."; }
		}
		public void Execute(GameClient Session, Room Room, string[] Params)
		{
			if (Params.Length == 1)
			{
				Session.SendWhisper("Bitte gib einen Habbonamen ein (:ausrauben <Habbo>).");
				return;
			}
			GameClient TargetClient = BiosEmuThiago.GetGame().GetClientManager().GetClientByUsername(Params[1]);
			if (TargetClient == null)
			{
				Session.SendWhisper("Der Habbo konnte nicht gefunden werden.");
				return;
			}
			RoomUser TargetUser = Room.GetRoomUserManager().GetRoomUserByHabbo(TargetClient.GetHabbo().Id);
			if (TargetUser == null)
			{
				Session.SendWhisper("Der Habbo konnte nicht gefunden werden.");
			}
			if (TargetClient.GetHabbo().Username == Session.GetHabbo().Username)
			{
				Session.SendWhisper("Sehr witzig.");
				return;
			}
			RoomUser ThisUser = Room.GetRoomUserManager().GetRoomUserByHabbo(Session.GetHabbo().Id);
			if (ThisUser == null)
				return;

			if (!(Math.Abs(TargetUser.X - ThisUser.X) >= 2) || (Math.Abs(TargetUser.Y - ThisUser.Y) >= 2))
			{
                TargetClient.SendWhisper("Jemand versucht dich auszurauben. Du hast 8 Sekunden Zeit, um zu fliehen.");
				System.Threading.Thread.Sleep(2000);

                int AmountThiago;
                if (int.TryParse("30", out AmountThiago))
                {
                    if (Session.GetHabbo().Diamonds < AmountThiago)
                    {
                        Session.SendMessage(RoomNotificationComposer.SendBubble("erro", "Hoppla, du hast keine " + AmountThiago.ToString() + " Diamanten!"));
                    }
                }

                int Amount;
                if (int.TryParse("30", out Amount))
                {
                    if (TargetClient.GetHabbo().Diamonds > AmountThiago)
                    {
                        Session.GetHabbo().Diamonds -= Amount;
                        Session.SendMessage(new HabboActivityPointNotificationComposer(Session.GetHabbo().Diamonds, 0, 5));
                        Room.SendMessage(new ChatComposer(ThisUser.VirtualId, "" + TargetClient.GetHabbo().Username + " wurde gerade ausgeraubt. [-30 Diamanten]", 0, 9));
                    }
                }

                int Amount223;
                if (int.TryParse("30", out Amount223))
                {
                    if (TargetClient.GetHabbo().Diamonds > AmountThiago)
                    {
                        Session.GetHabbo().Diamonds += Amount;
                        Session.SendMessage(new HabboActivityPointNotificationComposer(Session.GetHabbo().Diamonds, 0, 5));
                        Room.SendMessage(new ChatComposer(ThisUser.VirtualId, "" + Session.GetHabbo().Username + " hat gerade 30 Diamanten geklaut. [+30 Diamanten]", 0, 9));
                    }
                }

            }
			else
			{
				Session.SendWhisper("Der Habbo steht zu weit weg.");
				return;
			}
		}
	}
}