﻿using Bios.Communication.Packets.Outgoing.Rooms.Avatar;

namespace Bios.HabboHotel.Rooms.Chat.Commands.User.Fun
{
    class DanceCommand :IChatCommand
    {
        public string PermissionRequired => "command_dance";
        public string Parameters => "<1-4>";
        public string Description => "Einen eingeübten Tanz tanzen.";

        public void Execute(GameClients.GameClient Session, Rooms.Room Room, string[] Params)
        {
            RoomUser ThisUser = Session.GetHabbo().CurrentRoom.GetRoomUserManager().GetRoomUserByHabbo(Session.GetHabbo().Id);
            if (ThisUser == null)
                return;

            if (Params.Length == 1)
            {
                Session.LogsNotif("Bitte gib eine ID ein (:dance <1-4>).", "command_notification");
                return;
            }

            int DanceId;
            if (int.TryParse(Params[1], out DanceId))
            {
                if (DanceId > 4 || DanceId < 0)
                {
                    Session.LogsNotif("Bitte gib eine ID ein (:dance <1-4>).", "command_notification");
                    return;
                }

                Session.GetHabbo().CurrentRoom.SendMessage(new DanceComposer(ThisUser, DanceId));
            }
            else
            {
                Session.LogsNotif("Bitte gib eine ID ein (:dance <1-4>).", "command_notification");
                return;
            }
        }
    }
}
