﻿using Bios.Communication.Packets.Outgoing.Rooms.Notifications;
using Bios.Database.Interfaces;
using Bios.HabboHotel.GameClients;
using System;
using System.Data;
namespace Bios.HabboHotel.Rooms.Chat.Commands.User.Fun
{
    internal class HeiratenCommand : IChatCommand
    {
        private string _Casado;

        private string _Pedido;

        private string _TargetPedido;

        private string _TargetCasado;

        public string PermissionRequired
        {
            get
            {
                return "";
            }
        }

        public string Parameters
        {
            get
            {
                return "<Aktion> <Habbo>";
            }
        }

        public string Description
        {
            get
            {
                return "Einen Habbo heiraten!";
            }
        }

        public void Execute(GameClient Session, Room Room, string[] Params)
        {
            Session.SendWhisper("[ACHTUNG] ... Text", 34);
            bool flag = Params.Length == 1;
            if (flag)
            {
                Session.SendWhisper("Einen Heiratsantrag stellen (:heiraten antrag <nick>).", 34);
                Session.SendWhisper("Sich von einem Habbo scheiden lassen (:heiraten scheidung).", 34);
                Session.SendWhisper("Einen Heiratsantrag annehmen (:heiraten annehmen).", 34);
                Session.SendWhisper("Einen Heiratsantrag ablehnen (:heiraten ablehnen).", 34);

            }

            else
            {

                bool flag2 = Params.Length > 2;
                if (flag2)
                {
                    GameClient TargetClient = BiosEmuThiago.GetGame().GetClientManager().GetClientByUsername(Params[2]);
                    using (IQueryAdapter dbClient = BiosEmuThiago.GetDatabaseManager().GetQueryReactor())
                    {
                        dbClient.SetQuery("SELECT * FROM `users` WHERE `id` = " + TargetClient.GetHabbo().Id);
                        DataRow GetCasado = dbClient.getRow();
                        bool flag3 = GetCasado["casado"] != null || Convert.ToString(GetCasado["casado"]) == "";
                        if (flag3)
                        {
                            this._TargetCasado = Convert.ToString(GetCasado["casado"]);
                        }
                        else
                        {
                            this._TargetCasado = "";
                        }
                        bool flag4 = GetCasado["pedidodecasamento"] != null || Convert.ToString(GetCasado["pedidodecasamento"]) == "";
                        if (flag4)
                        {
                            this._TargetPedido = Convert.ToString(GetCasado["pedidodecasamento"]);
                        }
                        else
                        {
                            this._TargetPedido = "";
                        }
                    }
                }
                using (IQueryAdapter dbClient2 = BiosEmuThiago.GetDatabaseManager().GetQueryReactor())
                {
                    dbClient2.SetQuery("SELECT * FROM `users` WHERE `id` = " + Session.GetHabbo().Id);
                    DataRow GetCasado2 = dbClient2.getRow();
                    bool flag5 = GetCasado2["casado"] != null || Convert.ToString(GetCasado2["casado"]) == "";
                    if (flag5)
                    {
                        this._Casado = Convert.ToString(GetCasado2["casado"]);
                    }
                    else
                    {
                        this._Casado = "";
                    }
                    bool flag6 = GetCasado2["pedidodecasamento"] != null || Convert.ToString(GetCasado2["pedidodecasamento"]) == "";
                    if (flag6)
                    {
                        this._Pedido = Convert.ToString(GetCasado2["pedidodecasamento"]);
                    }
                    else
                    {
                        this._Pedido = "";
                    }
                }
                bool flag7 = Params[1] == "antrag";
                if (flag7)
                {
                    using (IQueryAdapter dbClient3 = BiosEmuThiago.GetDatabaseManager().GetQueryReactor())
                    {
                        bool flag8 = this._TargetCasado == null || this._TargetCasado == "";
                        if (flag8)
                        {
                            bool flag9 = this._TargetPedido == null || this._TargetPedido == "";
                            if (flag9)
                            {
                                GameClient TargetClient2 = BiosEmuThiago.GetGame().GetClientManager().GetClientByUsername(Params[2]);
                                dbClient3.SetQuery("UPDATE users SET pedidodecasamento='" + Session.GetHabbo().Username + "' WHERE id = @UserId");
                                dbClient3.AddParameter("UserId", TargetClient2.GetHabbo().Id);
                                dbClient3.RunQuery();
                                TargetClient2.SendMessage(new RoomNotificationComposer("Wooow! *o*", "<font size='15'><b>" + Session.GetHabbo().Username + "</b> hat dir einen Heiratsantrag gestellt.</font>\n Tippe (:heiraten annhemen) um den Antrag anzunehmen oder tippe (:heiraten ablehnen) um den Antrag abzulehnen.", "", "", ""));
                            }
                            else
                            {
                                Session.SendWhisper("Oops, dem Habbo wurde erst vor kurzem ein Heiratsantrag gestellt..", 34);
                            }
                        }
                        else
                        {
                            Session.SendWhisper("Oops, dieser Habbo ist bereits verheiratet.", 34);
                        }
                    }
                }
                bool flag10 = Params[1] == "annehmen";
                if (flag10)
                {
                    using (IQueryAdapter dbClient4 = BiosEmuThiago.GetDatabaseManager().GetQueryReactor())
                    {
                        dbClient4.SetQuery("SELECT * FROM `users` WHERE `id` = " + Session.GetHabbo().Id);
                        DataRow GetCasado3 = dbClient4.getRow();
                        string PedidoDe = Convert.ToString(GetCasado3["pedidodecasamento"]);
                        bool flag11 = PedidoDe != "";
                        if (flag11)
                        {
                            GameClient TargetClient3 = BiosEmuThiago.GetGame().GetClientManager().GetClientByUsername(PedidoDe);
                            using (IQueryAdapter SaveCasamento = BiosEmuThiago.GetDatabaseManager().GetQueryReactor())
                            {
                                SaveCasamento.SetQuery("UPDATE `users` SET pedidodecasamento='', casado=@User WHERE id = " + Session.GetHabbo().Id);
                                SaveCasamento.AddParameter("@User", PedidoDe);
                                SaveCasamento.RunQuery();
                            }
                            using (IQueryAdapter SaveCasamento2 = BiosEmuThiago.GetDatabaseManager().GetQueryReactor())
                            {
                                SaveCasamento2.SetQuery("UPDATE `users` SET pedidodecasamento='', casado=@User WHERE id = " + TargetClient3.GetHabbo().Id);
                                SaveCasamento2.AddParameter("@User", Session.GetHabbo().Username);
                                SaveCasamento2.RunQuery();
                            }

                            Session.SendWhisper("Verheiratet! *oo*" + PedidoDe + " ist jetzt nun deine Liebe. Du kannst dich scheiden mit (:heiraten scheidung).", 34);
                            TargetClient3.SendWhisper("Verheiratet *oo*" + Session.GetHabbo().Username + " ist jetzt nun deine Liebe. Du kannst dich scheiden mit (:heiraten scheidung).", 34);


                            using (IQueryAdapter dbClient = BiosEmuThiago.GetDatabaseManager().GetQueryReactor())
                            {
                                // Altera a missão.
                                dbClient.RunQuery("UPDATE users SET motto = 'Casado com " + Session.GetHabbo().Username + "' WHERE Id = '" + TargetClient3.GetHabbo().Id + "' LIMIT 1");
                                dbClient.RunQuery("UPDATE users SET motto = 'Casado com " + TargetClient3.GetHabbo().Username + "' WHERE Id = '" + Session.GetHabbo().Id + "' LIMIT 1");
                                dbClient.RunQuery();
                                // Coloca o usuário 1 no <3
                                dbClient.SetQuery("INSERT INTO user_relationships (`user_id`, `target`, `type`) VALUES " + "(@userid, @target, '1');");
                                dbClient.AddParameter("userid", Session.GetHabbo().Id);
                                dbClient.AddParameter("target", TargetClient3.GetHabbo().Id);
                                dbClient.RunQuery();
                                // Coloca o usuário 2 no <3 
                                dbClient.SetQuery("INSERT INTO user_relationships (`user_id`, `target`, `type`) VALUES " + "(@userid, @target, '1');");
                                dbClient.AddParameter("userid", TargetClient3.GetHabbo().Id);
                                dbClient.AddParameter("target", Session.GetHabbo().Id);
                                dbClient.RunQuery();

                                BiosEmuThiago.GetGame().GetClientManager().SendMessage(RoomNotificationComposer.SendBubble("casar", "Der Habbo " + TargetClient3.GetHabbo().Username + " ist jetzt nun mit " + Session.GetHabbo().Username + " verheiratet!"));

                            }
                        }

                        else
                        {
                            Session.SendWhisper("Nenhum Pedido! :(", 34);
                        }
                    }
                }
                bool flag12 = Params[1] == "ablehnen";
                if (flag12)
                {
                    using (IQueryAdapter dbClient5 = BiosEmuThiago.GetDatabaseManager().GetQueryReactor())
                    {
                        dbClient5.SetQuery("SELECT * FROM `users` WHERE `id` = " + Session.GetHabbo().Id);
                        DataRow GetCasado4 = dbClient5.getRow();
                        string PedidoDe2 = Convert.ToString(GetCasado4["pedidodecasamento"]);
                        bool flag13 = PedidoDe2 != "";
                        if (flag13)
                        {
                            using (IQueryAdapter SaveCasamento3 = BiosEmuThiago.GetDatabaseManager().GetQueryReactor())
                            {
                                SaveCasamento3.SetQuery("UPDATE `users` SET pedidodecasamento='' WHERE id = " + Session.GetHabbo().Id);
                                SaveCasamento3.RunQuery();
                            }
                            Session.SendWhisper("Du hast die Anfrage von " + PedidoDe2 + " abgelehnt!", 0);
                            GameClient TargetClient4 = BiosEmuThiago.GetGame().GetClientManager().GetClientByUsername(PedidoDe2);
                            TargetClient4.SendMessage(new RoomNotificationComposer("Es tut uns leid", "<b>" + Session.GetHabbo().Username + "</b> hat deinen Heiratsantrag nicht angenommen.\n\nSei nicht traurig, es gibt noch soviele andere Habbo Spieler.", "", "", ""));
                        }
                        else
                        {
                            Session.SendWhisper("Você não tem pedidos!", 34);
                        }
                    }
                }

                bool flag14 = Params[1] == "scheidung";
                if (flag14)

                {

                    using (IQueryAdapter dbClient6 = BiosEmuThiago.GetDatabaseManager().GetQueryReactor())
                    {
                        dbClient6.SetQuery("SELECT * FROM `users` WHERE `id` = " + Session.GetHabbo().Id);
                        DataRow GetCasado5 = dbClient6.getRow();
                        string CasadoCom = Convert.ToString(GetCasado5["casado"]);
                        bool flag15 = CasadoCom != "";
                        if (flag15)

                        {
                            GameClient TargetClient3 = BiosEmuThiago.GetGame().GetClientManager().GetClientByUsername(CasadoCom);
                            using (IQueryAdapter SaveCasamento4 = BiosEmuThiago.GetDatabaseManager().GetQueryReactor())
                            {
                                SaveCasamento4.SetQuery("UPDATE `users` SET pedidodecasamento='', casado='' WHERE id = " + Session.GetHabbo().Id);
                                SaveCasamento4.RunQuery();
                                // Deleta o <3 do usuário 1
                                SaveCasamento4.SetQuery("DELETE FROM `user_relationships` WHERE `user_id` = '" + Session.GetHabbo().Id + "' AND `target` = @target LIMIT 1");
                                SaveCasamento4.AddParameter("target", TargetClient3.GetHabbo().Id);
                                SaveCasamento4.RunQuery();
                                // Deleta o <3 do usuário 2
                                SaveCasamento4.SetQuery("DELETE FROM `user_relationships` WHERE `user_id` = '" + TargetClient3.GetHabbo().Id + "' AND `target` = @target LIMIT 1");
                                SaveCasamento4.AddParameter("target", Session.GetHabbo().Id);
                                SaveCasamento4.RunQuery();
                                // Deleta a missão
                                SaveCasamento4.RunQuery("UPDATE users SET motto = '' WHERE Id = '" + TargetClient3.GetHabbo().Id + "' LIMIT 1");
                                SaveCasamento4.RunQuery("UPDATE users SET motto = '' WHERE Id = '" + Session.GetHabbo().Id + "' LIMIT 1");
                            }
                            Session.SendWhisper("Du bist jetzt nun von " + CasadoCom + " geschieden!", 34);
                            GameClient TargetClient5 = BiosEmuThiago.GetGame().GetClientManager().GetClientByUsername(CasadoCom);
                            TargetClient5.SendMessage(new RoomNotificationComposer("</3", "<b>" + Session.GetHabbo().Username + "</b> es ist aus zwischen euch.\n", "", "", ""));
                        }
                        else
                        {
                            Session.SendWhisper("Du bist nicht verheiratet.", 34);
                        }
                    }
                }
            }
        }
    }
}
