﻿using System;
using Bios.HabboHotel.GameClients;
using Bios.Communication.Packets.Outgoing.Rooms.Chat;


namespace Bios.HabboHotel.Rooms.Chat.Commands.User.Fun
{
    class KissCommand : IChatCommand
    {
        public string PermissionRequired => "command_kiss";
        public string Parameters => "<Habbo>";
        public string Description => "Einen Habbo küssen.";

        public void Execute(GameClient Session, Room Room, string[] Params)
        {
            if (Params.Length == 1)
            {
                Session.SendWhisper("Lutfen bir Habbo adi gir! (:kuss <Habbo>).");
                return;
            }
            GameClient Target = BiosEmuThiago.GetGame().GetClientManager().GetClientByUsername(Params[1]);
            if (Target == null)
            {
                Session.SendWhisper("Bu Habbo bulunamadi.");
                return;
            }
            else
            {
                RoomUser TargetID = Room.GetRoomUserManager().GetRoomUserByHabbo(Target.GetHabbo().Id);
                RoomUser User = Room.GetRoomUserManager().GetRoomUserByHabbo(Session.GetHabbo().Id);
                if (TargetID == null)
                {
                    Session.LogsNotif("Bu Habbo bulunamadi, sanirim cevrimdisi veya ayni odada degilsiniz.", "command_notification");
                    return;
                }
                else if (Target.GetHabbo().Username == Session.GetHabbo().Username)
                {
                    Session.SendWhisper("D");
                    Room.SendMessage(new ChatComposer(User.VirtualId, "*Sadece kendini öpmeye çalıştın.*", 0, 34));
                    return;
                }
                else if (TargetID.TeleportEnabled)
                {
                    Session.LogsNotif("Bu kullanici teleport modunda.", "command_notification");
                    return;
                }
                else
                {
                    if (User != null)
                    {
                        if ((Math.Abs((int)(TargetID.X - User.X)) < 2) && (Math.Abs((int)(TargetID.Y - User.Y)) < 2))
                        {
                            Room.SendMessage(new ChatComposer(User.VirtualId, "*Optu " + Params[1] + " yanagindan!*", 0, 16));
                            Room.SendMessage(new ChatComposer(TargetID.VirtualId, "*Ofkelendi, ama ne? oda optu " + Session.GetHabbo().Username + " yanagindan*", 0, 16));
                            TargetID.ApplyEffect(9);
                            User.ApplyEffect(9);
                            System.Threading.Thread.Sleep(2000);
                            TargetID.ApplyEffect(0);
                            User.ApplyEffect(0);

                        }
                        else
                        {
                            Session.SendWhisper("Habbo cok uzak.");
                            return;
                        }
                    }
                }
            }
        }

    }
}