﻿using System;
using Bios.HabboHotel.GameClients;
using Bios.Communication.Packets.Outgoing.Rooms.Chat;

namespace Bios.HabboHotel.Rooms.Chat.Commands.User.Fun
{
	class MatarCommand : IChatCommand
	{
		public string PermissionRequired
		{
			get { return "command_sit"; }
		}
		public string Parameters
		{
			get { return "<Habbo>"; }
		}
		public string Description
		{
			get { return "Einen Habbo töten."; }
		}
		public void Execute(GameClient Session, Room Room, string[] Params)
		{
			if (Params.Length == 1)
			{
				Session.SendWhisper("Oldurmek istediginiz Habbonun adini girin! (:kill <Habbo>).");
				return;
			}
			GameClient TargetClient = BiosEmuThiago.GetGame().GetClientManager().GetClientByUsername(Params[1]);
			if (TargetClient == null)
			{
				Session.SendWhisper("Bu Habbo bulunamadi.");
				return;
			}
			RoomUser TargetUser = Room.GetRoomUserManager().GetRoomUserByHabbo(TargetClient.GetHabbo().Id);
			if (TargetUser == null)
			{
                Session.SendWhisper("Bu Habbo bulunamadi.");
            }
            if (TargetClient.GetHabbo().Username == Session.GetHabbo().Username)
			{
				Session.SendWhisper("Hiç komik değil!");
				return;
			}
			RoomUser ThisUser = Room.GetRoomUserManager().GetRoomUserByHabbo(Session.GetHabbo().Id);
			if (ThisUser == null)
				return;

            if ((Math.Abs((int)(TargetUser.X - ThisUser.X)) < 2) && (Math.Abs((int)(TargetUser.Y - ThisUser.Y)) < 2))
            {
				Room.SendMessage(new ChatComposer(ThisUser.VirtualId, "Silahini aldi ve su kisiye hedef aldi " + Params[1] + "*", 0, 3));
                System.Threading.Thread.Sleep(1000);
                ThisUser.ApplyEffect(539);
                Room.SendMessage(new ChatComposer(TargetUser.VirtualId, "* " + Session.GetHabbo().Username + " tarafindan vuruldu!*", 0, 3));
                System.Threading.Thread.Sleep(1000);
                Room.SendMessage(new ChatComposer(ThisUser.VirtualId, "*" + Session.GetHabbo().Username + " onu yere yigdi!*", 0, 3));
                System.Threading.Thread.Sleep(100);
                Room.SendMessage(new ChatComposer(ThisUser.VirtualId, "*PAW*", 0, 1));
                System.Threading.Thread.Sleep(100);
                Room.SendMessage(new ChatComposer(ThisUser.VirtualId, "*PEW*", 0, 1));
                System.Threading.Thread.Sleep(100);
                Room.SendMessage(new ChatComposer(ThisUser.VirtualId, "*POW*", 0, 1));
                System.Threading.Thread.Sleep(1000);
                Room.SendMessage(new ChatComposer(TargetUser.VirtualId, "*" + Params[1] + " öldü ve yerde yatiyor!*", 0, 7));
                TargetUser.Statusses.Add("lay", "0.1");
				TargetUser.isLying = true;
				TargetUser.UpdateNeeded = true;
			}
			else
			{
				Session.SendWhisper("Bu Habbo çok uzak.");
				return;
			}
		}
	}
}