﻿using Bios.Communication.Packets.Outgoing.Rooms.Engine;
using System.Text;
using Bios.Communication.Packets.Outgoing.Notifications;

namespace Bios.HabboHotel.Rooms.Chat.Commands.User.Fun 
{
    class PetCommand : IChatCommand
    {
        public string PermissionRequired => "command_pet";
        public string Parameters => "";
        public string Description => "Sich in ein Tier transformieren.";

        public void Execute(GameClients.GameClient Session, Room Room, string[] Params)
        {
            

            RoomUser RoomUser = Session.GetHabbo().CurrentRoom.GetRoomUserManager().GetRoomUserByHabbo(Session.GetHabbo().Id);
            if (RoomUser == null)
                return;

            if (!Room.PetMorphsAllowed)
            {
                Session.SendWhisper("Der Raumbesitzer hat diesen Befehl deaktiviert.");
                if (Session.GetHabbo().PetId > 0)
                {
                    Session.SendWhisper("Du hast noch eine Transformation.");
                    Session.GetHabbo().PetId = 0;

                    Room.SendMessage(new UserRemoveComposer(RoomUser.VirtualId));
                    Room.SendMessage(new UsersComposer(RoomUser));
                }
                return;
            }

            if (Params.Length == 1)
            {
                StringBuilder List = new StringBuilder("");
                Session.SendMessage(new MOTDNotificationComposer("Liste aller Tiere, in denen du dich verwandeln kannst.\n" +
                "···········································\n" +
                ":pet habbo » Dein altes Ich.\n" +
                "····································\n" +
                ":pet hund » Hund.\n" +
                "····································\n" +
                ":pet katze » Katze.\n" +
                "····································\n" +
                ":pet terrier » Besonderer Hund.\n" +
                "····································\n" +
                ":pet krokodil » Krokodil.\n" +
                "····································\n" +
                ":pet bär » Großer Bär.\n" +
                "····································\n" +
                ":pet schwein » Schmutziges Schwein.\n" +
                "····································\n" +
                ":pet löwe » Aggressiver Löwe.\n" +
                "····································\n" +
                ":pet rhino » Starkes Nashorn.\n" +
                "····································\n" +
                ":pet spinne » Eklige Spinne.\n" +
                "····································\n" +
                ":pet schildkröte » Langsame Schildkröte.\n" +
                "····································\n" +
                ":pet küken » Kleines Küken.\n" +
                "····································\n" +
                ":pet frosch » Grüner Frosch.\n" +
                "····································\n" +
                ":pet drache » Fliegender Drache.\n" +
                "····································\n" +
                ":pet affe » Alberner Affe.\n" +
                "····································\n" +
                ":pet pferd » Schnelles Pferd.\n" +
                "····································\n" +
                ":pet hase » Süßes Häschen.\n" +
                "····································\n" +
                ":pet schweinelord » Böses Schwein.\n" +
                "····································\n" +
                ":pet demon » Böser Demon.\n" +
                "····································\n" +
                ":pet gnome » Lustiger Gnome.\n" +
                "····································\n" +
                ":pet raptor » Gefährlicher Raptor.\n" +
                "····································\n" +
                ":pet dino » Süßes Dinosaurier.\n" +
                "····································\n" +
                ":pet elefant » Kräftiger Elefant.\n" +
                "····································\n" +
                ":pet supermario » Flinker Super Mario.\n" +
                "····································\n" +
                ":pet lobo » Lobo.\n" +
                "····································\n" +
                ":pet pikachu » Pikachu.\n"));
                return;
            }

            int TargetPetId = GetPetIdByString(Params[1].ToString());
            if (TargetPetId == 0)
            {
                Session.SendWhisper("Das Tier existiert nicht.");
                return;
            }

            //Change the users Pet Id.
            Session.GetHabbo().PetId = (TargetPetId == -1 ? 0 : TargetPetId);

            //Quickly remove the old user instance.
            Room.SendMessage(new UserRemoveComposer(RoomUser.VirtualId));

            //Add the new one, they won't even notice a thing!!11 8-)
            Room.SendMessage(new UsersComposer(RoomUser));

            //Tell them a quick message.
            if (Session.GetHabbo().PetId > 0)
                Session.SendWhisper("Schreibe (:pet habbo) um dich in dein altes Ich zurückzuverwandeln.");
        }

        private int GetPetIdByString(string Pet)
        {
            switch (Pet.ToLower())
            {
                default:
                    return 0;
                case "habbo":
                    return -1;
                case "hund":
                    return 60;//This should be 0.
                case "katze":
                case "1":
                    return 1;
                case "terrier":
                case "2":
                    return 2;
                case "krokodil":
                case "croco":
                case "3":
                    return 3;
                case "bär":
                case "4":
                    return 4;
                case "schwein":
                case "cerdo":
                case "kill":
                case "5":
                    return 5;
                case "löwe":
                case "rawr":
                case "6":
                    return 6;
                case "nashorn":
                case "7":
                    return 7;
                case "spinne":
                case "arana":
                case "araña":
                case "8":
                    return 8;
                case "schildkröte":
                case "9":
                    return 9;
                case "küken":
                case "chicken":
                case "pollo":
                case "10":
                    return 10;
                case "frosch":
                case "rana":
                case "11":
                    return 11;
                case "drache":
                case "dragon":
                case "12":
                    return 12;
                case "affe":
                case "mono":
                case "14":
                    return 14;
                case "pferd":
                case "caballo":
                case "15":
                    return 15;
                case "hase":
                case "conejo":
                case "17":
                    return 17;
                case "schweinelord":
                case "pajaro":
                case "21":
                    return 21;
                case "demon":
                case "demonio":
                case "23":
                    return 23;
                case "babybär":
                case "bebeoso":
                case "24":
                    return 24;
                case "babyhund":
                case "bebeterrier":
                case "25":
                    return 25;
                case "gnome":
                case "gnomo":
                case "26":
                    return 26;
                case "kitten":
                case "gatito":
                case "28":
                    return 28;
                case "puppy":
                case "perrito":
                case "29":
                    return 29;
                case "piglet":
                case "cerdito":
                case "30":
                    return 30;
                case "haloompa":
                case "31":
                    return 31;
                case "rock":
                case "piedra":
                case "32":
                    return 32;
                case "pterodactyl":
                case "pterosaur":
                case "33":
                    return 33;
                case "raptor":
                case "velociraptor":
                case "34":
                    return 34;
                case "vaca":
                case "35":
                    return 35;
                case "pinguino":
                case "36":
                    return 36;
                case "elefante":
                case "37":
                    return 37;
                case "bebeguapo":
                case "38":
                    return 38;
                case "bebefeo":
                case "39":
                    return 39;
                case "supermario":
                case "mario":
                case "40":
                    return 40;
                case "pikachu":
                case "41":
                    return 41;
                case "lobo":
                case "42":
                    return 42;
            }
        }
    }
}