﻿using System;
using System.Linq;
using System.Text;
using System.Collections.Generic;

using Bios.HabboHotel.Rooms;

namespace Bios.HabboHotel.Rooms.Chat.Commands.User.Fun
{
    class roomSelllCommand : IChatCommand
    {
        public string PermissionRequired
        {
            get { return ""; }
        }

        public string Parameters
        {
            get { return "<Preis>"; }
        }

        public string Description
        {
            get { return "Einen beliebigen Raum verkaufen."; }
        }

        public void Execute(GameClients.GameClient Session, Rooms.Room CurrentRoom, string[] Params)
        {
            RoomUser User = CurrentRoom.GetRoomUserManager().GetRoomUserByHabbo(Session.GetHabbo().Id);

            if (User == null)
                return;



            if (Params.Length == 1 || Params[1].Length < 2)
            {
                Session.SendWhisper("Bitte gib einen Preis an (:raumverkaufen <Preis>).", 3);
                return;
            }

            string ActualInput = Params[1];

            if (CurrentRoom.RoomData.OwnerId != User.HabboId)
            {
                Session.SendWhisper("Der Raum muss schon dir gehören. ", 3);
                return;
            }
            string roomCostType = ActualInput.Substring(ActualInput.Length - 1);
            int roomCost;
            try
            {
                roomCost = int.Parse(ActualInput.Substring(0, ActualInput.Length - 1));
            }
            catch
            {
                User.GetClient().SendWhisper("Gib bitte einen gültigen Preis ein.", 3);
                return;
            }

            if (roomCost == 0)
            {
                CurrentRoom.RoomData.roomForSale = false;
                CurrentRoom.RoomData.roomSaleCost = 0;
                CurrentRoom.RoomData.roomSaleType = "";
                Session.SendWhisper("Wenn der Raum verkauft wird, ist er nicht mehr für dich verfügbar.", 3);
                User.RoomOfferPending = false;
                User.RoomOffer = "";
                return;
            }

            if (roomCost < 1 || roomCost > 10000000)
            {
                User.GetClient().SendWhisper("Ungültiger Zimmerpreis wurde angegeben.", 3);
                return;
            }

            if (ActualInput.EndsWith("c") || ActualInput.EndsWith("d"))
            {
                CurrentRoom.RoomData.roomForSale = true;
                CurrentRoom.RoomData.roomSaleCost = roomCost;
                CurrentRoom.RoomData.roomSaleType = roomCostType;
            }
            else
            {
                Session.SendWhisper("Ungültige Eingabe.", 3);
                return;
            }

            foreach (RoomUser UserInRoom in CurrentRoom.GetRoomUserManager().GetRoomUsers().ToList())
            {
                if (UserInRoom != null)
                {
                    UserInRoom.GetClient().SendWhisper("Dieser Raum wird für " + roomCost + roomCostType + " verkauft, schreibe :raumkaufen, " + roomCost + roomCostType + " um den Raum zu kaufen.", 5);
                }
            }


        }
    }
}