﻿using System;
using System.Linq;
using System.Text;
using System.Data;
using System.Collections.Generic;
using Bios.Communication.Packets.Outgoing.Users;
using Bios.Communication.Packets.Outgoing.Notifications;
using Bios.Communication.Packets.Outgoing.Handshake;
using Bios.Communication.Packets.Outgoing.Quests;
using Bios.HabboHotel.Items;
using Bios.Communication.Packets.Outgoing.Inventory.Furni;
using Bios.Communication.Packets.Outgoing.Catalog;
using Bios.HabboHotel.Quests;
using Bios.HabboHotel.Rooms;
using System.Threading;
using Bios.HabboHotel.GameClients;
using Bios.Communication.Packets.Outgoing.Rooms.Avatar;
using Bios.Communication.Packets.Outgoing.Pets;
using Bios.Communication.Packets.Outgoing.Messenger;
using Bios.HabboHotel.Users.Messenger;
using Bios.Communication.Packets.Outgoing.Rooms.Polls;
using Bios.Communication.Packets.Outgoing.Rooms.Notifications;
using Bios.Communication.Packets.Outgoing.Availability;
using Bios.Communication.Packets.Outgoing;


namespace Bios.HabboHotel.Rooms.Chat.Commands.Events
{
    class HelpCommand : IChatCommand
    {
        public string PermissionRequired => "command_info";
        public string Parameters => "<Naricht>";
        public string Description => "Kurze Hilfeanfrage abschicken.";

        public void Execute(GameClient Session, Room Room, string[] Params)
        {
            long nowTime = BiosEmuThiago.CurrentTimeMillis();
            long timeBetween = nowTime - Session.GetHabbo()._lastTimeUsedHelpCommand;
            if (timeBetween < 60000)
            {
                Session.SendMessage(RoomNotificationComposer.SendBubble("abuse", "Du musst mind. 1 Minute warten, um den Support erneut nutzen zu können.", ""));
                return;
            }

            Session.GetHabbo()._lastTimeUsedHelpCommand = nowTime;
            string Request = CommandManager.MergeParams(Params, 1);

            if (Params.Length == 1)
            {
                Session.SendMessage(new RoomNotificationComposer("Support-System:", "<font color='#B40404'><b>Achtung, " + Session.GetHabbo().Username + "!</b></font>\n\n<font size=\"11\" color=\"#1C1C1C\">Das Supportsystem ist darauf ausgelegt, detaillierte Hilfe - Anfragen zu stellen. Du kannst also keine leere Nachricht absenden, weil sie nutzlos ist.\n\n" +
                 "Wenn du Hilfe brauchst, beschreibe dein Problem <font color='#B40404'> <b> so genau wie möglich.</b></font>. \n\nDas System erkennt, wenn Du diese Anforderungen missbrauchst, sende nicht mehr als eine Naricht oder du bekommst eine Verwarnung.\n\n" +
                 "Lembre-se que você também tem ajuda central para resolver seus problemas.", "help_user", ""));
                return;
            }
            else

                BiosEmuThiago.GetGame().GetClientManager().StaffAlert(new RoomNotificationComposer("Hilfeanfrage!",
                 "Der Habbo " + Session.GetHabbo().Username + " benötigt die Hilfe eines Botschafters.<br></font></b><br>Folgendes Problem wurde geschildert:<br><b>s"
                 + Request + "</b></font><br><br>Kümmere dich um das Problem und helfe dem Habbo. Deine Arbeit wird im Hintergrund kontrolliert.", "Hilf mir!", "" + Session.GetHabbo().Username + " besuchen", "event:navigator/goto/" + Session.GetHabbo().CurrentRoomId));

            BiosEmuThiago.GetGame().GetAchievementManager().ProgressAchievement(Session, "ACH_GuideEnrollmentLifetime", 1);
            Session.SendMessage(RoomNotificationComposer.SendBubble("ambassador", "Die Hilfeanfrage wurde erfolgreich abgeschickt. Warte einen Moment...", ""));
        }
    }
}



