﻿using System;
using System.Linq;
using System.Text;
using System.Data;
using System.Collections.Generic;
using Bios.Communication.Packets.Outgoing.Users;
using Bios.Communication.Packets.Outgoing.Notifications;
using Bios.Communication.Packets.Outgoing.Handshake;
using Bios.Communication.Packets.Outgoing.Quests;
using Bios.HabboHotel.Items;
using Bios.Communication.Packets.Outgoing.Inventory.Furni;
using Bios.Communication.Packets.Outgoing.Catalog;
using Bios.HabboHotel.Quests;
using Bios.HabboHotel.Rooms;
using Bios.Communication.Packets.Outgoing.Rooms.Chat;
using System.Threading;
using Bios.HabboHotel.GameClients;
using Bios.Communication.Packets.Outgoing.Rooms.Avatar;
using Bios.Communication.Packets.Outgoing.Pets;
using Bios.Communication.Packets.Outgoing.Messenger;
using Bios.HabboHotel.Users.Messenger;
using Bios.Communication.Packets.Outgoing.Rooms.Polls;
using Bios.Communication.Packets.Outgoing.Rooms.Notifications;
using Bios.Communication.Packets.Outgoing.Availability;
using Bios.Communication.Packets.Outgoing;


namespace Bios.HabboHotel.Rooms.Chat.Commands.Events
{
    class WerberCommand : IChatCommand
    {
        public string PermissionRequired => "command_info";
        public string Parameters => "<Werber>";
        public string Description => "Einen Werber melden.";

        public void Execute(GameClient Session, Room Room, string[] Params)
        {
            long nowTime = BiosEmuThiago.CurrentTimeMillis();
            long timeBetween = nowTime - Session.GetHabbo()._lastTimeUsedHelpCommand;
            if (timeBetween < 60000)
            {
                Session.SendMessage(RoomNotificationComposer.SendBubble("abuse", "Du musst mind. 1 Minute warten, um eine weitere Idee einzureichen.", ""));
                return;
            }

            Session.GetHabbo()._lastTimeUsedHelpCommand = nowTime;
            string Request = CommandManager.MergeParams(Params, 1);

            if (Params.Length == 1)
            {
                Session.SendWhisper("Bitte gib eine Idee ein (:werber <Habbo>)");
            }
            else

                BiosEmuThiago.GetGame().GetClientManager().StaffAlert(new WhisperComposer(1, "Werber von " + Session.GetHabbo().Username + " gemeldet: " + Request + "", 0, 34));

            BiosEmuThiago.GetGame().GetAchievementManager().ProgressAchievement(Session, "ACH_GuideEnrollmentLifetime", 1);
            Session.SendMessage(RoomNotificationComposer.SendBubble("ambassador", "Der Werber wurde erfolgreich gemeldet.", ""));
        }
    }
}



