﻿using System;
using Bios.Core;
using Bios.HabboHotel.GameClients;
using Bios.Communication.Packets.Outgoing.Rooms.Notifications;

namespace Bios.HabboHotel.Rooms.Chat.Commands.User
{
    class InfoCommand : IChatCommand
    {
        public string PermissionRequired => "command_pickall";
        public string Parameters => "";
        public string Description => "";

        public void Execute(GameClient Session, Room Room, string[] Params)
        {
            TimeSpan Uptime = DateTime.Now - BiosEmuThiago.ServerStarted;
            int OnlineUsers = BiosEmuThiago.GetGame().GetClientManager().Count;
            int RoomCount = BiosEmuThiago.GetGame().GetRoomManager().Count;

            Session.SendMessage(new RoomNotificationComposer("ReexEmulator",
                 "<font color=\"#0653b4\"><b>Reex Bilgi</b></font>\n" +
                 "<font size=\"11\" color=\"#1C1C1C\">ReexEmulator Version: 1.2.7</font>" +
                 "<font size=\"11\" color=\"#1C1C1C\"></font>\n\n" +
                 "<font size=\"13\" color=\"#1C1C1C\"><b>Aktif uyeler: </b> " + OnlineUsers + "</font>\n\n" +
                 "<font color=\"#d36b1b\" size=\"13\"><b>Gelistiriciler:</b></font>\n" +
                 "<font size=\"11\" color=\"#8c000e\"><b>xEsat</b></font>\n\n" +
                 "<font color=\"#0077d2\">Lisans: <b>www.Reexhotel.biz</b></font>\n\n", "", ""));
        }
    }
}
